
	.486
	.model flat,stdcall
	OPTION casemap:none
	option proc:private

	include	Httpdint.inc
	include	utility.inc

;*** http server: creates accept() + client threads

?PORT			equ 80		;http default port
?SOCKETTAB		equ 1		;1 = do a clean server shutdown


;*** global functions

InitServer		PROTO			;init winsocket, bind + listen
ServeClient		PROTO	:DWORD	;get + serve client request

if ?SOCKETTAB
CClientThread	struct
hSocket	DWORD ?
hThread	DWORD ?
CClientThread	ends
endif

	.data?

g_szRoot	db	MAX_PATH dup (?)	;root directory
g_szConfig	db	MAX_PATH dup (?)	;httpd.ini full filename
g_szServerName	db	32 dup (?)

	.data

g_hHeap					dd					0
g_lpfnprintf            LPFNPRINTF          0
g_pISAPI				DWORD				0
g_pISAPIMapping			DWORD				0
g_iPort					DWORD				0
g_hServerThread			HANDLE				0
g_hSock					dd					INVALID_SOCKET
g_dwMaxLen				dd					0
g_dwAccThrd				dd					0
g_dwVersion				dd					000092
g_wsdata				WSADATA				<>
g_lpfnTransmitFile		LPFNTRANSMITFILE	0
g_lpfnWSAGetOverlappedResult LPFNWSAGETOVERLAPPEDRESULT	0
g_hMswSock				dd					0
g_dwFlags               dd                  0
g_cs					CRITICAL_SECTION	<>
g_sa					sockaddr_in			<>

g_dwAccConnections		dd					0
g_dwCurConnections		dd					0
g_dwMaxConnections		dd					0
g_dwReusedConnections	dd					0
g_dwBytesReceived		dd					0
g_dwBytesSent			dd					0

;g_hostinfo				dd					?
g_binMode				db					FALSE
g_bLogRequests			BOOLEAN				FALSE
g_bIsPlatformNT			BOOLEAN				FALSE

	.code

;*** init winsocket

InitServer	proc
	
	invoke	WSAStartup,101h,addr g_wsdata
	.if	(eax == INVALID_SOCKET)
		invoke	printf, CStr("error at WSAStartup()")
		return 0
	.endif
	invoke printf, addr g_wsdata.szDescription
	movzx eax,g_wsdata.wVersion
	invoke printf, CStr("socket version %u"),eax

	invoke	socket,AF_INET,SOCK_STREAM,0
	mov		g_hSock,eax
	.if	(eax == INVALID_SOCKET)
		invoke	printf, CStr("error at socket()")
		return 0
	.endif

	invoke	htons,g_iPort
	mov		g_sa.sin_port,ax
	mov		g_sa.sin_family,PF_INET
	mov		g_sa.sin_addr.S_un.S_addr,0			;any address

	invoke	bind,g_hSock,addr g_sa,sizeof sockaddr_in
	.if	(eax == SOCKET_ERROR)
		invoke	closesocket,g_hSock
		invoke	printf, CStr("error at bind()")
		return 0
	.endif

	invoke	listen,g_hSock, SOMAXCONN
	.if	(eax == SOCKET_ERROR)
		invoke	closesocket,g_hSock
		invoke	printf, CStr("error at listen()")
		return 0
	.endif
	invoke	printf, CStr("listening for connections at port %u"), g_iPort
	return 1
	align 4

InitServer	endp


;*** ServeClient executes in an own thread for every accepted connection
;*** class CHTTPRequest reads client data and serves request
;*** parameter hSocket may be a socket or a ptr to CClientThread

ServeClient	proc	uses ebx hSocket:DWORD

	mov eax,hSocket
if ?SOCKETTAB
	mov eax,[eax.CClientThread.hSocket]
endif
	invoke	Create@CHTTPRequest, eax
	.if (eax)
		mov ebx, eax
		invoke GetData@CHTTPRequest, ebx
		invoke Destroy@CHTTPRequest, ebx
	.endif
	dec g_dwCurConnections
if ?SOCKETTAB
	mov eax,hSocket
	mov dword ptr [eax.CClientThread.hSocket],INVALID_SOCKET
	mov dword ptr [eax.CClientThread.hThread],NULL
endif
	invoke	ExitThread,0
	align 4

ServeClient endp

;*** AcceptLoop is the "server" thread
;*** if ?SOCKETTAB = 1, server maintains an array of
;*** open sockets + thread handles on its stack in structure CClientThread
;*** which should provide for a clean shutdown


AcceptLoop	proc	parm:DWORD

LOCAL	dwThreadId:DWORD
LOCAL	rc:DWORD
local	remote_sin:SOCKADDR_IN
local	remote_sin_len:DWORD
if ?SOCKETTAB
LOCAL	dwSocketTabSize:DWORD
endif

if ?SOCKETTAB
	mov dwSocketTabSize, 0
endif
	invoke printf,CStr("server accept loop started")
    mov remote_sin_len, sizeof remote_sin
	.while (1)
		invoke accept, g_hSock, addr remote_sin, addr remote_sin_len
if 0    
        push eax
		invoke printf,CStr("accept(%X)=%d"), g_hSock, eax
        pop eax
endif   
		.break .if (eax == INVALID_SOCKET)
		inc g_dwAccConnections
		mov	edx,eax
		mov eax,g_dwMaxConnections
		inc g_dwCurConnections
		.if (eax < g_dwCurConnections)
			inc g_dwMaxConnections
		.endif
if ?SOCKETTAB
;-------------------------------- store socket+hThread in array on stack
		mov ecx,dwSocketTabSize
		mov eax,esp
		.while (ecx)
			.if (dword ptr [eax.CClientThread.hSocket] == INVALID_SOCKET)
				mov [eax.CClientThread.hSocket],edx
				.break
			.endif
			add eax,sizeof CClientThread
			dec ecx
		.endw
		.if (!ecx)					;new entry required?
			sub esp,sizeof CClientThread
			mov eax,esp
			mov [eax.CClientThread.hSocket],edx
			mov [eax.CClientThread.hThread],NULL
			inc dwSocketTabSize
		.endif
		mov edx,eax
		push edx
endif
		invoke CreateThread,0,0,offset ServeClient,edx,0,addr dwThreadId
if ?SOCKETTAB
		pop edx
		mov [edx.CClientThread.hThread],eax
endif
	.endw
	invoke	WSAGetLastError
	mov rc,eax

	invoke printf,CStr("server accept loop terminated")

if ?SOCKETTAB
	mov ecx,dwSocketTabSize
	mov eax,esp
	.while (ecx)
		mov edx,[eax.CClientThread.hSocket]
		.if (edx != INVALID_SOCKET)
			pushad
			push edx
			invoke	shutdown, edx, SD_BOTH
			pop edx
			invoke	closesocket, edx
			popad
		.endif
		add eax,sizeof CClientThread
		dec ecx
	.endw
	mov ecx,dwSocketTabSize
	mov eax,esp
	.while (ecx)
		.if (dword ptr [eax.CClientThread.hThread])
			pushad
			invoke WaitForSingleObject, dword ptr [eax.CClientThread.hThread], INFINITE
			popad
		.endif
		add eax,sizeof CClientThread
		dec ecx
	.endw
endif
	invoke printf,CStr("server thread terminating")

	return rc
	align 4

AcceptLoop	endp


DisplayStats@CHTTPServer proc public

	invoke printf, CStr("accepted connections: %u"), g_dwAccConnections
	invoke printf, CStr("open connections: %u"), g_dwCurConnections
	invoke printf, CStr("max. open connections: %u"), g_dwMaxConnections
	invoke printf, CStr("reused connections: %u"), g_dwReusedConnections
	invoke printf, CStr("bytes received: %u"), g_dwBytesReceived
	invoke printf, CStr("bytes sent: %u"), g_dwBytesSent
	ret
	align 4

DisplayStats@CHTTPServer endp

Reset@CHTTPServer proc public
	xor eax,eax
	mov g_dwAccConnections, eax
;	mov g_dwCurConnections, eax		dont reset that
	mov g_dwMaxConnections, eax
	mov g_dwReusedConnections, eax
	mov g_dwBytesReceived, eax
	mov g_dwBytesSent, eax
	ret
	align 4
Reset@CHTTPServer endp


SetOption@CHTTPServer proc public dwOption:DWORD, dwValue:DWORD
	xor eax, eax
	mov ecx, dwOption
    mov edx, dwValue
    .if (ecx == 0)
    	mov g_bLogRequests, dl
        inc eax
    .endif
	ret
	align 4
SetOption@CHTTPServer endp


GetRoot@CHTTPServer proc public pszRoot:ptr BYTE, dwMax:DWORD

	invoke lstrcpyn, pszRoot, addr g_szRoot, dwMax
    mov eax, 1
	ret
	align 4
    
GetRoot@CHTTPServer endp


Create@CHTTPServer	proc public uses esi edi pszServerName:ptr BYTE, pszConfig:ptr BYTE, lpfnprintf:LPFNPRINTF, dwFlags:DWORD

local	ovi:OSVERSIONINFO
local	szCurDir[MAX_PATH]:byte
local	szSection[32]:byte
local	szPath[2048]:byte

	invoke	GetProcessHeap
	mov 	g_hHeap,eax
   
    invoke  lstrcpyn, addr g_szServerName, pszServerName, sizeof g_szServerName
    invoke  lstrcpyn, addr g_szConfig, pszConfig, sizeof g_szConfig

    mov		eax, lpfnprintf
    mov		ecx, dwFlags
    mov		g_lpfnprintf, eax
    mov		g_dwFlags, ecx

	mov		ovi.dwOSVersionInfoSize, sizeof OSVERSIONINFO
	invoke	GetVersionEx, addr ovi
	.if (ovi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
		mov al,FALSE
	.else
		mov al,TRUE
	.endif
	mov		g_bIsPlatformNT, al
    .if (al)
    	invoke LoadLibrary, CStr("MSWSOCK.DLL")
        .if (eax)
        	mov g_hMswSock, eax
            invoke GetProcAddress, eax, CStr("TransmitFile")
            mov g_lpfnTransmitFile, eax
        .endif
    	invoke GetModuleHandle, CStr("WS2_32.DLL")
        .if (eax)
            invoke GetProcAddress, eax, CStr("WSAGetOverlappedResult")
            mov g_lpfnWSAGetOverlappedResult, eax
        .endif
    .endif

	mov eax, g_dwVersion
	movzx ecx,ax
	shr eax,16
	invoke printf, CStr("%s version %u.%02u initializing..."), addr g_szServerName,
		eax, ecx

	invoke printf, CStr("config file is '%s'"), addr g_szConfig

;------------------------------ get root directory (default current dir)
	invoke	GetCurrentDirectory, sizeof szCurDir, addr szCurDir
	invoke	lstrcpy, addr szSection, CStr("options")
	invoke	GetPrivateProfileString, addr szSection, CStr("root"),\
		addr szCurDir, addr g_szRoot, sizeof g_szRoot, addr g_szConfig

	invoke	lstrlen, addr g_szRoot
	mov		ecx,MAX_PATH
	sub		ecx,eax
	mov		g_dwMaxLen,ecx

;------------------------------ get port (default 80)
	invoke	GetPrivateProfileInt, addr szSection, CStr("port"), ?PORT,\
		addr g_szConfig
	mov		g_iPort,eax

;------------------------------ get AddPath (will be added to Path env var)
	invoke	GetPrivateProfileString, addr szSection, CStr("AddPath"),\
		CStr(""), addr szCurDir+1, sizeof szCurDir-1, addr g_szConfig
	.if (eax)
		mov szCurDir, ';'
		inc eax
		push eax
		invoke GetEnvironmentVariable, CStr("Path"), addr szPath, sizeof szPath
		pop ecx
		add ecx,eax
		.if (ecx < sizeof szPath)
			invoke lstrcat, addr szPath, addr szCurDir
			invoke SetEnvironmentVariable, CStr("Path"), addr szPath
			invoke printf, CStr("'%s' added to PATH environment variable"), addr szCurDir+1
		.endif
	.endif

;------------------------------ get mappings
;------------------------------ load ISAPI dlls
	invoke malloc, 7FFFh
	.if (eax)
		mov esi, eax
		invoke GetPrivateProfileSection, CStr("mappings"), esi, 7FFFh, addr g_szConfig
		lea edi, g_pISAPIMapping
		push esi
		.while (byte ptr [esi])
			.if (byte ptr [esi] == '.')
				lodsd
				.if (byte ptr [esi-1] == '=')
					and eax, 0FFFFFFh
					or eax,202020h
				.elseif (byte ptr [esi] == '=')
					inc esi
					or eax,20202020h
				.endif
				invoke LoadISAPIExtension, esi, eax
				.if (eax)
					invoke printf, CStr("loaded: %s"), esi
				.else
					invoke printf, CStr("refused: %s"), esi
				.endif
			.endif
			invoke lstrlen, esi
			add esi, eax
			inc esi
		.endw
		pop esi
		invoke free, esi
	.endif

	invoke InitServer
	.if (!eax)
		ret
	.endif

	invoke	InitializeCriticalSection, addr g_cs

	invoke CreateThread, 0, 0, offset AcceptLoop, 0, 0, addr g_dwAccThrd
	mov g_hServerThread, eax

	invoke printf, CStr("mount point is %s"), addr g_szRoot
	invoke printf, CStr("server initialized")
	return 1
	align 4

Create@CHTTPServer	endp

Destroy@CHTTPServer	proc public uses esi

local	dwRC:DWORD

	invoke printf, CStr("begin server shutdown")
	.if (g_hSock != INVALID_SOCKET)
		invoke shutdown, g_hSock, SD_BOTH
        .if (eax == -1)
        	invoke WSAGetLastError
			invoke printf, CStr("shutdown(%X)=-1 [%u]"), g_hSock, eax
        .else
			invoke printf, CStr("shutdown(%X)=%d"), g_hSock, eax
        .endif
        invoke Sleep, 0
		invoke closesocket, g_hSock
		invoke printf, CStr("closesocket(%X)=%X"), g_hSock, eax
        invoke Sleep, 0
        mov g_hSock, INVALID_SOCKET
        .if (g_hServerThread)
			.if (g_dwFlags & 1)
				invoke MsgWaitForMultipleObjects, 1, addr g_hServerThread, 0, 10000, QS_SENDMESSAGE or QS_PAINT
            .else
				invoke WaitForSingleObject, g_hServerThread, 10000
            .endif
            .if (eax == STATUS_TIMEOUT)
            	invoke printf, CStr("*** timeout waiting for server thread to terminate")
        	.endif
			invoke GetExitCodeThread, g_hServerThread, addr dwRC
            mov g_hServerThread, 0
        .endif
		invoke printf, CStr("server thread terminated [%u]"), dwRC
	.endif
	invoke WSACleanup
	xor esi, esi
	xchg esi,g_pISAPI
	assume esi:ptr CIsapi
	.while (esi)
		.if ([esi].pTE)
			invoke [esi].pTE, HSE_TERM_MUST_UNLOAD
		.endif
		invoke FreeLibrary, [esi].hLib
		invoke free, [esi].pszName
		mov ecx, esi
		mov esi,[esi].pNext
		invoke free, ecx
	.endw

	xor esi, esi
	xchg esi,g_pISAPIMapping
	.while (esi)
		.if ([esi].pTE)
;-------------------------------- for associated dlls avoid calling a dll twice
			mov eax, [esi].pTE
			mov ecx, [esi].pNext
			.while (ecx)
				.break .if (eax == [ecx].CIsapi.pTE)
				mov ecx,[ecx].CIsapi.pNext
			.endw
;-------------------------------- if ecx == NULL it doesnt exist twice
			.if (!ecx)
				invoke [esi].pTE, HSE_TERM_MUST_UNLOAD
			.endif
		.endif
		invoke FreeLibrary, [esi].hLib
		mov ecx, esi
		mov esi,[esi].pNext
		invoke free, ecx
	.endw

	invoke	DeleteCriticalSection, addr g_cs
    
   	xor ecx, ecx
    xchg ecx, g_hMswSock
    .if (ecx)
    	invoke FreeLibrary, ecx
    .endif

	assume esi:nothing
	ret
	align 4

Destroy@CHTTPServer	endp

DllMain proc stdcall public hModule:dword, reason:dword, dwReserved:dword

	mov ecx, reason		
	.if (ecx == DLL_PROCESS_ATTACH)
	    mov eax,1
    .elseif (ecx == DLL_PROCESS_DETACH)
    	.if (g_hSock != INVALID_SOCKET)
        	invoke Destroy@CHTTPServer
        .endif
    .endif
    ret
    
DllMain endp

	end DllMain
