
;--- console interface for HTTPD

	.486
	.model flat,stdcall
	OPTION casemap:none
	option proc:private

WIN32_LEAN_AND_MEAN equ 1	
	.nolist
    .nocref
    include windows.inc
    include stdio.inc
    .cref
    .list
    include macros.inc
	include	Httpd.inc

;*** main program:

	.const

g_szServerName	db	'httpdASM',0

	.data?

;g_szRoot	db	MAX_PATH dup (?)	;root directory
g_szConfig	db	MAX_PATH dup (?)	;httpd.ini full filename

	.data

g_hInstance		HINSTANCE 0
g_hConOut		dd 0
g_hConInp		dd 0
g_hMutex		dd 0

g_bLogRequests	BOOLEAN		FALSE

	.const
    
strMenu label byte
	db "httpdASM menu:",13,10
	db "'1'   - print statistics",13,10
	db "'2'   - start shell",13,10
	db "'ESC' - terminate server",13,10
SIZEMENU equ $ - strMenu

strExitMsg label byte
	db "httpdASM: type 'exit' to return to the server",13,10
SIZEEXITMSG equ $ - strExitMsg

strBackMsg label byte
	db "httpdASM: back from shell",13,10
SIZEBACKMSG equ $ - strBackMsg

	.code

;*** display protocol line

myprintf	proc c public pStr:LPSTR, parms:VARARG

	pushad
	invoke WaitForSingleObject, g_hMutex, INFINITE
	sub	esp,1024
	mov esi,esp
	invoke vsprintf, esi, pStr, addr parms
	invoke printf, esi
	invoke printf, CStr(<0dh,0ah>)
	add esp,1024
	invoke ReleaseMutex, g_hMutex
	popad
	ret
	align 4

myprintf	endp

;*** do app initialization stuff

InitApp	proc hInstance:HINSTANCE

	invoke  GetStdHandle, STD_OUTPUT_HANDLE
    mov		g_hConOut, eax

	invoke GetStdHandle, STD_INPUT_HANDLE
    mov		g_hConInp, eax
    invoke	SetConsoleMode, eax, 0	;disable mouse
    
	invoke	GetModuleFileName, NULL, addr g_szConfig, sizeof g_szConfig
	lea		ecx,g_szConfig
	mov		dword ptr [ecx+eax-3],"ini"
    
    invoke	CreateMutex, 0, 0, 0
    mov		g_hMutex, eax
    
	ret
	align 4

InitApp endp

;--- start a shell process

StartShell proc

local	dwWritten:DWORD
local	sinfo:STARTUPINFO
local	pi:PROCESS_INFORMATION
local	szPath[MAX_PATH]:byte

		invoke GetEnvironmentVariableA, CStr("COMSPEC"), addr szPath, sizeof szPath
		.if (eax)
			invoke RtlZeroMemory, addr sinfo, sizeof STARTUPINFO
			mov sinfo.cb, sizeof STARTUPINFO
            invoke WriteConsole, g_hConOut, addr strExitMsg, SIZEEXITMSG, addr dwWritten, 0
			invoke CreateProcess, NULL, addr szPath, 0, 0, 0, 0, 0, 0, addr sinfo, addr pi 
			.if (eax)
            	invoke WaitForSingleObject, pi.hProcess, INFINITE
                invoke WriteConsole, g_hConOut, addr strBackMsg, SIZEBACKMSG, addr dwWritten, 0
				invoke CloseHandle, pi.hThread
				invoke CloseHandle, pi.hProcess
			.endif
		.endif
		ret
StartShell endp

;--- program main loop

main proc argc:dword, argv:dword

	LOCAL	dwRead:DWORD
	LOCAL	ir:INPUT_RECORD

	invoke	InitApp, g_hInstance
	.if (!eax)
		ret
	.endif

	invoke Create@CHTTPServer, addr g_szServerName, addr g_szConfig, offset myprintf, 0
	.if (!eax)
		invoke printf, CStr(<"creating server failed",10>)
        jmp @exit
	.endif

	.WHILE	TRUE
    	invoke	WaitForSingleObject, g_hConInp, INFINITE
        invoke	ReadConsoleInput, g_hConInp, addr ir, 1, addr dwRead
        .if (eax && dwRead && (ir.EventType == KEY_EVENT) && (ir.Event.KeyEvent.bKeyDown))
        	movzx ecx, ir.Event.KeyEvent.wVirtualKeyCode
        	.if (ecx == VK_ESCAPE)
            	.break
            .elseif (ecx == VK_SPACE)
			    push 0
			    mov ecx, esp
			    invoke WriteConsole, g_hConOut, offset strMenu, SIZEMENU, ecx, 0
			    pop ecx
            .elseif (ecx == '1')
            	invoke printf, CStr(<"Statistics:",10>)
            	invoke DisplayStats@CHTTPServer
            .elseif (ecx == '2')
            	invoke StartShell
            .endif
        .endif
	.endw

	invoke	Destroy@CHTTPServer
@exit:    
    .if (g_hMutex)
    	invoke CloseHandle, g_hMutex
    .endif
    
	xor eax, eax
    
	ret
	align 4

main endp

mainCRTStartup proc public
	
	invoke	GetModuleHandle,0
	mov		g_hInstance,eax
	invoke	main, 0, 0
	invoke	ExitProcess,0
	align 4

mainCRTStartup endp

	end mainCRTStartup
