
;--- windows interface for HTTPD

	.486
	.model flat,stdcall
	OPTION casemap:none
	option proc:private

	.nolist
	.nocref
WIN32_LEAN_AND_MEAN equ 1    
	include windows.inc
	include	windowsx.inc
	include shellapi.inc
    include commctrl.inc
    
    include httpd.inc
	include macros.inc
	include debugout.inc
	.list
	.cref

	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib

?LISTVIEW 	equ 0

;*** equates + typedefs

ZeroMemory		equ <RtlZeroMemory>

;*** resource IDs (must match the definitions in RSRC.RC!)

IDD_DIALOG1		equ 101
IDC_EDIT1		equ 1002		

;*** menu command IDs

IDM_EXIT		equ 40001
IDM_CLEAR		equ 40002
IDM_TRAYICON	equ 40003
IDM_EXPLORE		equ 40004
IDM_RESTORE		equ 40005
IDM_STATISTIC	equ 40006
IDM_LOGREQUESTS	equ 40007
IDM_RESET		equ 40008
IDM_CONFIG		equ 40009
IDM_RESTART		equ 40010
IDM_ABOUT		equ 40011

;*** child window IDs

IDC_LIST1		equ 1000	;the listbox covering the client area

;*** main program: does GUI stuff

?OFFSET			equ 0		;size of frame for client area
?TRAYICON		equ 1		;1 = support option "icon in system area"
?TRAYICONON		equ 1		;1 = option "icon in system area" on as default
?MULTITHREADED	equ 1		;1 = use CoInitializeEx

WM_TASKBAR		equ	WM_USER+101

;*** global functions

ResizeWindow	PROTO	:DWORD

	.const

g_szServerName	db	'httpdASM',0

	.data?

g_szConfig	db	MAX_PATH dup (?)	;httpd.ini full filename

	.data

g_hInstance			HINSTANCE	0
g_hwndMain			HWND		0
g_hListBox			HWND		0
g_hMenu				HMENU		0
g_hIcon				HICON		0
g_hServer			DD			0

if ?TRAYICON
g_aTaskbarCreated	dd			0
endif
g_bTrayIcon			BOOLEAN		FALSE
g_bLogRequests		BOOLEAN		FALSE

	.const

pMenu	dd MF_POPUP or MF_ENABLED,	CStr("&File")
		dd MF_STRING or MF_ENABLED,	CStr("&Explore root"), IDM_EXPLORE
		dd MF_STRING or MF_ENABLED,	CStr("E&dit config file"), IDM_CONFIG
		dd MF_STRING or MF_ENABLED,	CStr("&Restart"), IDM_RESTART
		dd MF_SEPARATOR, 0, -1
		dd MF_STRING or MF_ENABLED,	CStr("E&xit"), IDM_EXIT
		dd MF_POPUP or MF_ENABLED,	CStr("&Options")
		dd MF_STRING or MF_ENABLED,	CStr("&Display statistics"), IDM_STATISTIC
		dd MF_STRING or MF_ENABLED,	CStr("&Log all requests"), IDM_LOGREQUESTS
		dd MF_STRING or MF_ENABLED,	CStr("&Reset statistics"), IDM_RESET
if ?TRAYICON
		dd MF_SEPARATOR, 0, -1
		dd MF_STRING or MF_ENABLED,	CStr("&Icon in Status Area"), IDM_TRAYICON
endif
		dd MF_SEPARATOR, 0, -1
		dd MF_STRING or MF_ENABLED,	CStr("&Clear display"), IDM_CLEAR
		dd MF_POPUP or MF_ENABLED,	CStr("&Help")
		dd MF_STRING or MF_ENABLED,	CStr("&About ..."), IDM_ABOUT
		dd -1


szAbout	db " httpdASM is open source.", 13,10
		db " First step coding was done by JademTech.", 13,10
		db " The rest was done by japheth.", 13,10
		db " Get the newest version from",13,10
		db " http://www.japheth.de."
		db 0

	.code

;*** display protocol line

printf	proc c public pStr:LPSTR, parms:VARARG

local lvi:LVITEM

	pushad
	sub	esp,1024
	mov esi,esp
	invoke wvsprintf, esi, pStr, addr parms
	.if (g_hListBox)
ife ?LISTVIEW
		invoke ListBox_AddString( g_hListBox, esi)
else
		invoke ListView_GetItemCount( g_hListBox)
        mov lvi.iItem, eax
        mov lvi.iSubItem, 0
        mov lvi.pszText, esi
        mov lvi.mask_, LVIF_TEXT
		invoke ListView_InsertItem( g_hListBox, addr lvi)
endif        
	.else
		invoke OutputDebugString, esi
		invoke OutputDebugString, CStr(<0dh,0ah>)
	.endif
	add esp,1024
	popad
	ret
	align 4

printf	endp

;*** adjust size of child windows to size of main window


ResizeWindow	proc	NewSize:DWORD

	mov		eax,NewSize
	mov		ecx,NewSize
	movzx	eax,ax		;mask x-bits
	shr		ecx,16		;mask y-bits

	sub		eax,?OFFSET*2
	sub		ecx,?OFFSET*2
	invoke	SetWindowPos, g_hListBox,0,?OFFSET,?OFFSET,eax,ecx,0
	ret
	align 4

ResizeWindow endp


if ?TRAYICON

ShowTrayIcon	proc	hWnd:HWND

local	nid:NOTIFYICONDATA

	.if (!g_aTaskbarCreated)
    	invoke RegisterWindowMessage, CStr("TaskbarCreated")
        mov g_aTaskbarCreated, eax
    .endif
	mov nid.cbSize,sizeof NOTIFYICONDATA
	mov eax,hWnd
	mov nid.hWnd, eax
	mov nid.uID, IDM_TRAYICON
	mov nid.uFlags, NIF_ICON or NIF_MESSAGE or NIF_TIP
	mov eax,g_hIcon
	mov nid.hIcon, eax
	mov nid.uCallbackMessage, WM_TASKBAR
	invoke wsprintf, addr nid.szTip, CStr("%s running"), addr g_szServerName
	.if (g_bTrayIcon == FALSE)
		mov ecx,NIM_ADD
		mov edx,MF_CHECKED or MF_BYCOMMAND
	.else
		mov ecx,NIM_DELETE
		mov edx,MF_UNCHECKED or MF_BYCOMMAND
	.endif
	push edx
	invoke Shell_NotifyIcon, ecx, addr nid
	pop edx
	invoke CheckMenuItem, g_hMenu, IDM_TRAYICON, edx
	xor g_bTrayIcon,1
	ret
	align 4

ShowTrayIcon	endp

;*** context menu if tray icon is right clicked

OnContextMenu proc hWnd:HWND

local hMenu:HMENU
local pt:POINT

;---------------------------------------- SetForeGroundWindow + PostMessage WM_NULL
;---------------------------------------- are neccessary for "technical reasons"
	invoke SetForegroundWindow, hWnd

	invoke CreatePopupMenu
	mov hMenu, eax
	invoke AppendMenu, hMenu, MF_STRING or MF_ENABLED, IDM_RESTORE, CStr("&Restore")
	invoke AppendMenu, hMenu, MF_STRING or MF_ENABLED, IDM_EXIT, CStr("&Close")
	invoke SetMenuDefaultItem, hMenu, IDM_RESTORE, FALSE
	invoke GetCursorPos,addr pt
	invoke TrackPopupMenu, hMenu,TPM_LEFTALIGN or TPM_LEFTBUTTON,\
						pt.x, pt.y, 0, hWnd, NULL
	invoke DestroyMenu, hMenu

	invoke PostMessage, hWnd, WM_NULL, 0, 0

	ret
	align 4

OnContextMenu endp

endif

AboutDlgProc proc	hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

	.if (uMsg == WM_INITDIALOG)
		invoke GetStockObject, DEFAULT_GUI_FONT
		.if (eax)
			invoke SendDlgItemMessage, hWnd, IDC_EDIT1, WM_SETFONT, eax, 0
		.endif
		invoke SetDlgItemText, hWnd, IDC_EDIT1, addr szAbout
		return 1
	.elseif (uMsg == WM_CLOSE)
		invoke EndDialog, hWnd, 0
	.elseif (uMsg == WM_COMMAND)
		movzx eax,word ptr wParam
		.if (eax == IDCANCEL)
			invoke EndDialog, hWnd, 0
		.endif
	.endif
	return 0

AboutDlgProc endp

DisplayStatistic proc hWnd:HWND

	invoke DisplayStats@CHTTPServer	
	ret
	align 4

DisplayStatistic endp

CreateChild proc hWnd:HWND

local	lvc:LVCOLUMN
local	rect:RECT

;-------------------------------------------- Create Listbox child
ife ?LISTVIEW
		invoke CreateWindowEx, WS_EX_STATICEDGE, CStr("listbox"),0,\
			WS_CHILD or WS_VISIBLE or WS_VSCROLL or LBS_NOTIFY or LBS_NOINTEGRALHEIGHT,\
			0,0,0,0, hWnd, IDC_LIST1, g_hInstance,0
		mov		g_hListBox,eax
;-------------------------------------------- set small font for listbox
		invoke GetStockObject, DEFAULT_GUI_FONT
		.if (eax)
			invoke SendMessage, g_hListBox, WM_SETFONT, eax, 0
		.endif
else
		invoke CreateWindowEx, WS_EX_STATICEDGE, CStr("Syslistview32"),0,\
			WS_CHILD or WS_VISIBLE or WS_VSCROLL or LVS_REPORT or LVS_NOCOLUMNHEADER,\
			0,0,0,0, hWnd, IDC_LIST1, g_hInstance,0
		mov		g_hListBox,eax
        .if (eax)
			invoke GetClientRect, hWnd, addr rect
			invoke GetWindowLong, g_hListBox, GWL_STYLE
			.if !(eax & WS_VSCROLL)
				invoke GetSystemMetrics, SM_CXVSCROLL
				sub rect.right,eax
			.endif
			dec rect.right
			mov eax, rect.right
			dec eax
			mov lvc.cx_, eax
			mov lvc.mask_, LVCF_WIDTH
    	    invoke ListView_InsertColumn(g_hListBox, 0, addr lvc)
        .endif
endif
		ret
CreateChild endp

;*** main window proc


WndProc proc	hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

	mov eax,uMsg
	.IF (eax == WM_CREATE)
    
    	invoke CreateChild, hWnd
        xor eax, eax

    .elseif (eax == WM_DESTROY)

;-------------------------------- no more display messages 
		mov g_hListBox, NULL

if ?TRAYICON
		.if (g_bTrayIcon)
			invoke ShowTrayIcon, hWnd
		.endif
endif
        invoke PostQuitMessage, 0

	.ELSEIF	(eax == WM_CLOSE)
    
		.if (g_hServer)
			invoke	Destroy@CHTTPServer
	        mov g_hServer, 0
    	.endif
        invoke DestroyWindow, hWnd

	.ELSEIF	(eax == WM_SIZE)

if ?TRAYICON
		.if ((wParam == SIZE_MINIMIZED) && g_bTrayIcon)
			invoke ShowWindow, hWnd, SW_HIDE
		.endif
endif
		invoke	ResizeWindow, lParam

	.ELSEIF (eax == WM_COMMAND)

		movzx eax,word ptr wParam
		.if (eax == IDM_EXIT)
			invoke PostMessage, hWnd, WM_CLOSE, 0, 0
		.elseif (eax == IDM_CLEAR)
			invoke ListBox_ResetContent( g_hListBox)
if ?TRAYICON
		.elseif (eax == IDM_TRAYICON)
			invoke ShowTrayIcon, hWnd
		.elseif (eax == IDM_RESTORE)
			invoke ShowWindow, hWnd, SW_RESTORE
endif
		.elseif (eax == IDM_EXPLORE)
        	sub esp, MAX_PATH
            mov ecx, esp
        	invoke GetRoot@CHTTPServer, ecx, MAX_PATH
            mov ecx, esp
			invoke ShellExecute, hWnd, CStr("explore"), ecx, CStr(""), NULL, SW_SHOWDEFAULT 
            add esp, MAX_PATH
		.elseif (eax == IDM_CONFIG)
			invoke ShellExecute, hWnd, CStr("open"), addr g_szConfig,\
				CStr(""), NULL, SW_SHOWDEFAULT 
		.elseif (eax == IDM_RESTART)

			.if (g_hServer)
				invoke Destroy@CHTTPServer
	            mov g_hServer, 0
            .endif
			invoke Create@CHTTPServer, addr g_szServerName, addr g_szConfig, offset printf, 1
            mov g_hServer, eax

		.elseif (eax == IDM_STATISTIC)
			invoke DisplayStatistic, hWnd
		.elseif (eax == IDM_LOGREQUESTS)
			mov edx,MF_UNCHECKED
			xor g_bLogRequests,1
			.if (!ZERO?)
				mov edx,MF_CHECKED
			.endif
			invoke CheckMenuItem, g_hMenu, IDM_LOGREQUESTS, edx
            
            movzx eax, g_bLogRequests 
            invoke SetOption@CHTTPServer, 0, eax
            
		.elseif (eax == IDM_RESET)
        	invoke Reset@CHTTPServer
		.elseif (eax == IDM_ABOUT)
			invoke DialogBoxParam, g_hInstance, IDD_DIALOG1,\
				hWnd, AboutDlgProc, 0
		.endif
if ?TRAYICON
	
	.elseif (eax == WM_TASKBAR)

		.if (lParam == WM_LBUTTONDBLCLK)

			invoke SetForegroundWindow, hWnd
			invoke ShowWindow, hWnd, SW_RESTORE

		.elseif (lParam == WM_RBUTTONUP)

			invoke OnContextMenu, hWnd

		.endif
        
	.elseif (eax && (eax == g_aTaskbarCreated))
    	mov g_bTrayIcon, 0
		invoke ShowTrayIcon, hWnd
endif
    .ELSE 
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .ENDIF
	return 0
	align 4

WndProc endp


;*** create a menu from table in .data


MakeMenu	proc uses esi pMenuRes:ptr DWORD

LOCAL	hMenu:HMENU
LOCAL	hPopupMenu:HMENU

	invoke CreateMenu
	mov hMenu, eax
	mov esi, pMenuRes
	.while (1)
		lodsd
		.break .if (eax == -1)
		.if (eax & MF_POPUP)
			push eax
			lodsd
			push eax
			invoke CreatePopupMenu
			mov hPopupMenu,eax
			pop ecx
			pop eax
			invoke AppendMenu, hMenu, eax, hPopupMenu, ecx
		.else
			mov ecx,eax
			lodsd
			mov edx,eax
			lodsd
			invoke AppendMenu, hPopupMenu, ecx, eax, edx
		.endif
	.endw
	mov eax,hMenu
	ret
	align 4

MakeMenu	endp


;*** do app initialization stuff


InitApp	proc hInstance:HINSTANCE

local	wc:WNDCLASSEX

	invoke	GetModuleFileName, NULL, addr g_szConfig, sizeof g_szConfig
	lea		ecx,g_szConfig
	mov		byte ptr [ecx+eax-5],"."
	mov		dword ptr [ecx+eax-4],"ini"

;-------------------------------------------- register window class
	invoke	ZeroMemory, addr wc, sizeof WNDCLASSEX

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		eax, hInstance
	mov		wc.hInstance,eax
	invoke	LoadCursor,0,IDC_ARROW
	mov		wc.hCursor,eax
	invoke	LoadIcon, hInstance, 1
	mov		g_hIcon,eax
	mov		wc.hIcon,eax
	mov		wc.hbrBackground,COLOR_WINDOW
	mov		wc.lpszClassName,OFFSET g_szServerName
	invoke	RegisterClassEx,addr wc

;-------------------------------------------- Create menu
	invoke MakeMenu, offset pMenu
	mov	g_hMenu, eax

;-------------------------------------------- Create main window
	invoke	CreateWindowEx,0,addr g_szServerName,addr g_szServerName,WS_OVERLAPPEDWINDOW,\
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
		0, g_hMenu, hInstance, 0
	mov		g_hwndMain,eax
	ret
	align 4

InitApp endp


WinMain proc hInstance:HINSTANCE,hPrevInstance:HINSTANCE,lpszCmdLine:LPSTR,iCmdShow:dword

	LOCAL	msg:MSG

	invoke	InitApp, hInstance
	.if (!eax)
		ret
	.endif

if ?TRAYICONON
	invoke SendMessage, g_hwndMain, WM_COMMAND, IDM_TRAYICON, 0
endif
	invoke	ShowWindow, g_hwndMain, iCmdShow

	invoke Create@CHTTPServer, addr g_szServerName, addr g_szConfig, offset printf, 1
    mov g_hServer, eax
	.if (!eax)
		invoke ShowWindow, g_hwndMain, SW_RESTORE
		invoke MessageBeep, MB_OK
		invoke MessageBox, g_hwndMain, CStr("server will be terminated"),0,MB_OK or MB_ICONSTOP
		invoke PostMessage, g_hwndMain, WM_COMMAND, IDM_EXIT, 0
	.endif
	
	.WHILE	TRUE
		invoke	GetMessage,addr msg,0,0,0
		.BREAK .IF(!eax)
		invoke	TranslateMessage,addr msg
		invoke	DispatchMessage,addr msg
	.endw

	mov	eax,msg.wParam
	ret
	align 4

WinMain endp

WinMainCRTStartup proc public
	
	invoke	GetModuleHandle,0
	mov		g_hInstance,eax
	invoke	WinMain, eax, 0, 0, SW_SHOW 
	invoke	ExitProcess,0
	align 4

WinMainCRTStartup endp

	end
