
;--- installs httpdASM as a service on NT platforms

	.386
	.model flat, stdcall
	option casemap: none

WIN32_LEAN_AND_MEAN equ 1
	.nolist
    .nocref
	include windows.inc
	include	macros.inc
    include httpd.inc
    .cref
    .list

@DbgOut macro x
if 1
	pushad
	invoke OutputDebugString, x
    popad
endif
	endm

protowvsprintf typedef proto stdcall :ptr byte, :ptr byte, :DWORD
LPFNWVSPRINTF typedef ptr protowvsprintf

myprintf	proto c pStr:LPSTR, parms:VARARG

	.data

paused		BOOL	0
running		BOOL	0

hServiceStatus	HANDLE	0
g_hModule	HANDLE	0
g_hThread	HANDLE	0
g_hMutex	HANDLE	0
evStop		HANDLE	0
g_hUser32	HANDLE	0
g_lpfnwvsprintf LPFNWVSPRINTF 0
g_hStdOut	dd -1
g_szConfig	db MAX_PATH dup (?)
g_szLog  	db MAX_PATH dup (?)

serv_tbl	SERVICE_TABLE_ENTRY	< 0, 0 >
			SERVICE_TABLE_ENTRY	< 0, 0 >

	.const

szServiceName	db	"httpdASM", 0

	.code

threadProc proc param :dword

    invoke	CreateMutex, 0, 0, 0
    mov		g_hMutex, eax
    
    @DbgOut CStr(<"threadproc",13,10>)
    
	invoke GetModuleFileName, g_hModule, addr g_szConfig, MAX_PATH
    mov ecx, offset g_szConfig
    .while (eax && (byte ptr [ecx+eax-1] != '\'))
    	dec eax
    .endw
    add ecx, eax
    invoke lstrcpy, ecx, CStr("httpd.ini")

    .if (g_hStdOut == -1)
		invoke GetModuleFileName, g_hModule, addr g_szLog, MAX_PATH
	    mov ecx, offset g_szLog
    	.while (eax && (byte ptr [ecx+eax-1] != '\'))
    		dec eax
	    .endw
    	add ecx, eax
	    invoke lstrcpy, ecx, CStr("httpd.log")
        invoke CreateFile, addr g_szLog, GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
        mov g_hStdOut, eax
    .endif
    
    @DbgOut CStr(<"calling Create@CHTTPServer",13,10>)
	invoke Create@CHTTPServer, addr szServiceName, addr g_szConfig, offset myprintf, 0
    and eax, eax
    jz @F
	.while (1)
		invoke Sleep, 5000
	.endw
@@:    
    .if (g_hMutex)
    	invoke CloseHandle, g_hMutex
        mov g_hMutex, 0
    .endif
	xor	eax, eax
	ret
threadProc endp


resume proc
	mov	paused, FALSE
	invoke	ResumeThread, g_hThread
	ret
resume endp

pause_ proc
	mov	paused, TRUE
	invoke	SuspendThread, g_hThread
	ret
pause_ endp

stop proc
	invoke Destroy@CHTTPServer
    .if (g_hStdOut != -1)
    	invoke CloseHandle, g_hStdOut
        mov g_hStdOut, -1
    .endif
	mov	running, TRUE
	invoke	SetEvent, evStop
	ret
stop endp


;--- prepare SERVICE_STATUS, then call SetServiceStatus


sendStatus proc	currentState:dword,	win32ExitCode:dword, servSpecExitCode:dword,
		checkPoint:dword, waitHint:dword

local	serv_stat:SERVICE_STATUS

	mov	serv_stat.dwServiceType, SERVICE_WIN32_OWN_PROCESS
	mov	eax, currentState
	mov	serv_stat.dwCurrentState, eax

	.if currentState == SERVICE_START_PENDING
		mov	serv_stat.dwControlsAccepted, 0
	.else
		mov	serv_stat.dwControlsAccepted,\
			SERVICE_ACCEPT_STOP or SERVICE_ACCEPT_PAUSE_CONTINUE or SERVICE_ACCEPT_SHUTDOWN
	.endif

	.if servSpecExitCode == 0
		mov	eax, win32ExitCode
		mov	serv_stat.dwWin32ExitCode, eax
	.else
		mov	serv_stat.dwWin32ExitCode, ERROR_SERVICE_SPECIFIC_ERROR
	.endif

	mov	eax, servSpecExitCode
	mov	serv_stat.dwServiceSpecificExitCode, eax
	mov	eax, checkPoint
	mov	serv_stat.dwCheckPoint, eax
	mov	eax, waitHint
	mov	serv_stat.dwWaitHint, eax

	invoke	SetServiceStatus, hServiceStatus, addr serv_stat
	mov	eax, TRUE
	ret
	align 4

sendStatus endp

;--- handle service control requests

ServiceHandlerProc proc controlCode:dword

local currentState :dword

	.if (paused) 
		mov	currentState, SERVICE_PAUSED
	.elseif (running)
		mov	currentState, SERVICE_RUNNING
	.else
		mov	currentState, SERVICE_STOPPED
	.endif

	mov	eax, [controlCode]

	; SERVICE_STOP_PENDING is probably +2 of SERVICE_CONTROL_STOP

	.if eax == SERVICE_CONTROL_STOP

	 	invoke	sendStatus, SERVICE_STOP_PENDING, NO_ERROR, 0, 1, 1000
	 	call	stop
	 	mov	currentState, SERVICE_STOP_PENDING

	.elseif eax == SERVICE_CONTROL_PAUSE
	 	.if ((running != 0) && (paused == 0))
	 		invoke	sendStatus, SERVICE_PAUSE_PENDING, NO_ERROR, 0, 1, 1000
	 		call	pause_
	 		mov	currentState, SERVICE_PAUSED
	 	.endif

	.elseif eax == SERVICE_CONTROL_CONTINUE
		.if ((running != 0) && (paused != 0))
			invoke	sendStatus, SERVICE_CONTINUE_PENDING, NO_ERROR, 0, 1, 1000
			call	resume
			mov	currentState, SERVICE_RUNNING
		.endif

	.elseif (eax == SERVICE_CONTROL_INTERROGATE)

		@DbgOut CStr(<"ServiceHandlerProc: SERVICE_CONTROL_INTERROGATE received",13,10>)

	.elseif (eax == SERVICE_CONTROL_SHUTDOWN)

		@DbgOut CStr(<"ServiceHandlerProc: SERVICE_CONTROL_SHUTDOWN",13,10>)

		; do nothing on shutdown .. ?
		jmp done

	.endif

	invoke	sendStatus, currentState, NO_ERROR, 0, 0, 0
done:
	ret

ServiceHandlerProc endp

;
;--- kill off the service
;

serviceStop proc err:dword

	.if evStop != 0
		invoke	CloseHandle, evStop
	.endif
	.if hServiceStatus != 0
		invoke	sendStatus, SERVICE_STOPPED, err, 0, 0, 0
	.endif

	.if g_hThread != 0
		invoke	CloseHandle, g_hThread
	.endif
	ret
serviceStop endp


;--- Service entry procedure, called after
;--- the call to "StartServiceCtrlDispatcher"


ServiceMain proc argc:dword, argv:ptr ptr BYTE

local tmp:dword

	@DbgOut CStr(<"https ServiceMain enter",13,10>)
    
	invoke	RegisterServiceCtrlHandler, addr szServiceName, ServiceHandlerProc
    and eax, eax
	jz	@@STOP_SERVICE1
	mov	hServiceStatus, eax

	invoke	sendStatus, SERVICE_START_PENDING, NO_ERROR, 0, 1, 5000

	; create the event to stop the service 
	invoke	CreateEvent, NULL, TRUE, FALSE, NULL
    and eax, eax
	jz	@@STOP_SERVICE2
	mov	evStop, eax

	invoke	sendStatus, SERVICE_START_PENDING, NO_ERROR, 0, 2, 1000
	invoke	sendStatus, SERVICE_START_PENDING, NO_ERROR, 0, 3, 5000

	invoke	CreateThread, 0, 0, threadProc, 0, 0, addr tmp
    and eax, eax
	jz	@@STOP_SERVICE3
	mov	g_hThread, eax
	mov	running, TRUE
	
	invoke	sendStatus, SERVICE_RUNNING, NO_ERROR, 0, 0, 0

;--- a ServiceMain proc does not return until service stops

	invoke	WaitForSingleObject, evStop, INFINITE
	invoke	serviceStop, 0
	ret

@@STOP_SERVICE1:
	@DbgOut CStr(<"RegisterServiceCtrlHandler failed",13,10>)
	invoke	serviceStop, 0
	ret
@@STOP_SERVICE2:
	@DbgOut CStr(<"CreateEvent failed",13,10>)
	invoke	serviceStop, 0
	ret
@@STOP_SERVICE3:
	@DbgOut CStr(<"CreateThread failed",13,10>)
	invoke	serviceStop, 0
	ret
ServiceMain endp

Getvsprintf proc
		.if (!g_hUser32)
        	invoke LoadLibrary, CStr("user32")
            mov g_hUser32, eax
        .endif
        .if (!g_lpfnwvsprintf)
        	.if (g_hUser32)
            	invoke GetProcAddress, g_hUser32, CStr("wvsprintfA")
                mov g_lpfnwvsprintf, eax
            .endif
        .endif
        ret
Getvsprintf endp        

;--- printf emulation
;--- load user32 dynamically

printf  proc c pszFormat:ptr BYTE, args:VARARG

local   dwWritten:DWORD
local   szOut[1024]:byte

		invoke Getvsprintf
        .if (g_lpfnwvsprintf)
        	.if (g_hStdOut == -1)
	        	invoke GetStdHandle, STD_OUTPUT_HANDLE
    	        mov g_hStdOut, eax
            .endif
	        invoke g_lpfnwvsprintf, addr szOut, pszFormat, addr args
	        lea ecx, dwWritten
    	    invoke WriteConsole, g_hStdOut, addr szOut, eax, ecx, NULL
        .endif
        ret
printf  endp

myprintf	proc c uses esi pStr:LPSTR, parms:VARARG

local	dwWritten:DWORD
local	szText[1024]:BYTE

    .if (g_hMutex)
		invoke WaitForSingleObject, g_hMutex, INFINITE
    .endif
	invoke Getvsprintf
	lea esi,szText
	invoke g_lpfnwvsprintf, esi, pStr, addr parms
    lea ecx, dwWritten
	invoke WriteFile, g_hStdOut, esi, eax, ecx, 0
	invoke WriteFile, g_hStdOut, CStr(<0dh,0ah>), 2, addr dwWritten, 0
    .if (g_hMutex)
		invoke ReleaseMutex, g_hMutex
    .endif
	ret
	align 4

myprintf	endp

installservice proc uses ebx bMode:dword

local hSCManager:DWORD
local szPathName[MAX_PATH]:byte

	@DbgOut CStr(<"https installservice enter",13,10>)

	mov hSCManager, 0
    
	invoke GetModuleFileName, NULL, addr szPathName, MAX_PATH
    lea ecx, szPathName
    .while (eax && (byte ptr [ecx+eax-1] != '\'))
    	dec eax
    .endw
    add ecx, eax
    invoke lstrcpy, ecx, CStr("httpds.exe") 
    .if (bMode == 0)
		invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
		.if (eax)
			mov hSCManager, eax
	        invoke OpenService, hSCManager, addr szServiceName, DELETE
	        .if (eax)
    	    	mov ebx, eax
            	invoke DeleteService, ebx
                .if (eax)
                	invoke printf, CStr(<"DeleteService('%s') succeeded",10>), addr szServiceName
                .else
                	invoke GetLastError
                	invoke printf, CStr(<"DeleteService('%s') failed [%X]",10>), addr szServiceName, eax
                .endif
	        	invoke CloseServiceHandle, ebx
	        .else
    	      	invoke GetLastError
        	   	invoke printf, CStr(<"OpenService('%s') failed [%X]",10>), addr szServiceName, eax
            .endif
        .else
	    	invoke GetLastError
		    invoke printf, CStr(<"OpenSCManager failed [%X]",10>), eax
        .endif

	.else
		invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
	    .if (eax)
	    	mov hSCManager, eax
			invoke CreateService, hSCManager,	addr szServiceName,\
				addr szServiceName, SERVICE_ALL_ACCESS,\
				SERVICE_WIN32_OWN_PROCESS,\;// service type 
				SERVICE_DEMAND_START,\     ;// start type 
				SERVICE_ERROR_NORMAL,\     ;// error control type 
				addr szPathName,\       ;// service's binary 
				NULL, NULL, NULL, NULL,	NULL
		    .if (eax == NULL) 
    	    	invoke GetLastError
			    invoke printf, CStr(<"CreateService('%s') failed [%X]",10>), addr szServiceName, eax 
		    .else 
            	mov ebx, eax
			    invoke printf, CStr(<"CreateService('%s') succeeded",10>), addr szServiceName
				invoke CloseServiceHandle, ebx
			.endif
		.else
    		invoke GetLastError
		    invoke printf, CStr(<"OpenSCManager failed [%X]",10>), eax
		.endif
	.endif
exit:
	.if (hSCManager)
        invoke CloseServiceHandle, hSCManager
    .endif
    ret
installservice endp


;--- program entry

mainCRTStartup:

	
	@DbgOut CStr(<"https mainCRTStartup",13,10>)
    
	invoke GetModuleHandle, NULL
    mov g_hModule, eax

	invoke GetCommandLine
    mov esi, eax
    .while (byte ptr [esi])
    	lodsb
        .if ((al == '/') || (al == '-'))
        	mov eax, [esi]
            and eax, 0FFFFFFh
            or  eax, 202020h
            .if (eax == "led") 	;/DEL?
				invoke installservice, 0
            	jmp exit
            .elseif (eax == "erc")	;/CRE?
				invoke installservice, 1
                jmp exit
            .elseif (al == '?')
            	invoke printf, CStr(<"usage: https [ options ]",10>)
            	invoke printf, CStr(<"options:",10>)
            	invoke printf, CStr(<" /CRE: create httpdASM Service",10>)
            	invoke printf, CStr(<" /DEL: delete httpdASM Service",10>)
            	invoke printf, CStr(<" /?:   print this help text",10>)
                jmp exit
            .endif
        .endif
    .endw


	mov	serv_tbl.lpServiceProc, offset ServiceMain
	mov	serv_tbl.lpServiceName, offset szServiceName

	@DbgOut CStr(<"https calling StartServiceCtrlDispatcher",13,10>)
	invoke	StartServiceCtrlDispatcher, addr serv_tbl
	.if (eax == 0)
		@DbgOut CStr(<"https StartServiceCtrlDispatcher failed",13,10>)
    	invoke GetLastError
		invoke printf, CStr(<"StartServiceCtrlDispatcher failed [%X]",10>), eax
	.endif
exit:	
	invoke	ExitProcess, 0

	end mainCRTStartup
