
	.486
	.model flat, stdcall
	option casemap :none
	option proc:private


	include Httpdint.inc
    .nolist
    .nocref
    include wininet.inc
    include mswsock.inc
	include Utility.inc
    .cref
    .list
    
;	includelib wininet.lib

?LOGREQUEST		equ 1		;1 = log request on Debug Terminal (DEBUG version only)
?BUFSIZE		equ 10000h	;64 kB input buffer size
?USEVIRTALLOC	equ 1		;1 = use VirtualAlloc for file buffer
?BUFFEREDOUT	equ 0		;1 = allow buffered output (bBuffered)
?BUFSIZOUT		equ 20000h	;128 kB initial output buffer if buffering on
?USEINTERLOCKED	equ 0		;use InterlockedExchangeAdd (not available in Win9x)
?TESTFULLPATH	equ 1		;1 to test some ISAPI extensions

;*** implements CHTTPRequest class
;*** this class does the real httpd work: reads client http request,
;*** transmits file to client or calls ISAPI extension.
;*** all members are private

CHTTPRequest	struct
hSocket			DWORD	?		;socket returned from accept()
pszHeaderOut	LPSTR	?		;total header for output
dwSizHeader		DWORD	?		;size of total header
pBufferIn		LPSTR	?		;buffer for input data
dwConLenIn		DWORD	?		;value of "Content-Length" for input
dwReadIn		DWORD	?		;bytes from body read in input buffer
pBufferOut		LPSTR	?		;buffer for output data
dwConLenOut		DWORD	?		;value of "Content-Length" for output
dwFreeOut		DWORD	?		;free bytes in output buffer
pszHeaderIn		LPSTR	?
pszHttpVer		LPSTR	?		;HTTP version string
pszMethod		LPSTR	?		;REQUEST_METHOD
Action			BYTE	?		;request method in short form (HTTP_GET, HTTP_POST)
bKeepAlive		BOOLEAN	?
bBuffered		BOOLEAN	?		;HTTP output is buffered
bHeaderSent		BOOLEAN	?
dwFlags			DWORD	?
dwCode			DWORD	?		;HTTP status code
pszExt			LPSTR	?		;points to extension of Filename 
pszQueryString	LPSTR	?		;pointer to query string (QUERY_STRING)
pszBodyIn		LPSTR	?		;pointer to body for input
dwExtension		DWORD	?
pfnIOCompletion PFN_HSE_IO_COMPLETION ?
pContext		DWORD	?
pszContTypeOut	LPSTR	?		;output content type
pszActionParam	LPSTR	?		;total action param 
overlapped		OVERLAPPED <>
szFileName		BYTE	256	dup(?)	;SCRIPT_NAME
szPathInfo		BYTE	256 dup(?)	;PATH_INFO
szFullPath		BYTE	256 dup(?)	;translated SCRIPT_NAME
szPathTranslated BYTE	256 dup(?)	;PATH_TRANSLATED
szHost			BYTE	64	dup(?)	;"Host:" header variable (not HOST_NAME)
szContType		BYTE	32	dup(?)	;CONTENT_TYPE
szIfModifiedSince BYTE	32	dup(?)	;If-Modified-Since
szLastModified	BYTE	32	dup(?)	;Last-Modified
CHTTPRequest	ends

;--- flags of dwFlags

HF_HOST_SUPPLIED	equ 1
HF_HTTP11_REQUEST	equ 2
HF_ABSOLUTE_PATH	equ 4

__this	textequ <ebx>
_this	textequ <[__this].CHTTPRequest>

	MEMBER hSocket, pszHeaderOut, dwSizHeader, pszHeaderIn
	MEMBER pBufferIn, dwConLenIn, dwReadIn
	MEMBER pBufferOut, dwConLenOut, dwFreeOut, dwFlags
	MEMBER pszHttpVer, Action, bKeepAlive, bBuffered, bHeaderSent
	MEMBER dwCode, pszExt, pszQueryString, pszMethod
	MEMBER pszBodyIn, szPathInfo, dwExtension, pfnIOCompletion
	MEMBER overlapped, pContext, pszContTypeOut
	MEMBER pszActionParam, szFileName, szHost, szFullPath, szPathTranslated
	MEMBER szContType, szLastModified, szIfModifiedSince

;*** CHTTPRequest private members
;*** since these functions cannot be called from outside
;*** the first parameter (this_) isnt really neccessary, because
;*** ebx will always point to the object. So it is sometimes omitted

SendHeader		PROTO
Send			PROTO	:ptr CHTTPRequest, :LPSTR, :DWORD
GetHTTPMethod	PROTO	:ptr CHTTPRequest, :LPSTR	;scan first line from client request
GetHTTPNextParm	PROTO	:ptr CHTTPRequest, :LPSTR	;scan next lines from client request
SendError		PROTO	:ptr CHTTPRequest			;send standard error messages
CallIsapi		PROTO	:ptr CHTTPRequest, :ptr CIsapi;calls HttpExtensionProc
FileTransfer	PROTO	:ptr CHTTPRequest			;Sends static response (=file) to client
ServeContent	PROTO	:ptr CHTTPRequest			;Sends response to client
SafeFilePath	PROTO	:ptr CHTTPRequest			;Ensures that the file being opened is safe and not violating security
ScanFilePath	PROTO	:ptr CHTTPRequest			;scan file path until we get a file name
ExtractFilename	PROTO	:ptr CHTTPRequest			;fills the path and filename member
SimTransmitFile PROTO	:ptr CHTTPRequest, :DWORD, :DWORD, :ptr TRANSMIT_FILE_BUFFERS
GetMIMEType		PROTO	

;*** other functions, no access to member vars

GetValue		PROTO	:LPSTR, :LPSTR, :DWORD	;strcpyn function
GetPathElement	PROTO	:LPSTR,:LPSTR			;Returns the next part of a path
TranslateUrl	PROTO	:LPSTR, :LPSTR, :DWORD	;translate to full qualified path
SearchISAPI		PROTO	:LPSTR


	.const


;---------------------------------------------- CVariable

;--- variable table for GetServerVariable callback

CVariable struct
pszName		LPSTR	?
dwOffset	DWORD	?
bType		BYTE	?
CVariable ends

CVTT_LPSTR	equ 0
CVTT_DWORD	equ 1
CVTT_STRING	equ 2
CVTT_DWABS	equ 3
CVTT_FUNC	equ 4


VarTab label CVariable
	CVariable <CStr("ALL_HTTP"), GetAllHttp, CVTT_FUNC>
	CVariable <CStr("CONTENT_LENGTH"), CHTTPRequest.dwConLenIn, CVTT_DWORD>
	CVariable <CStr("CONTENT_TYPE"), CHTTPRequest.szContType, CVTT_STRING>
	CVariable <CStr("PATH_INFO"), CHTTPRequest.szPathInfo, CVTT_STRING>
	CVariable <CStr("PATH_TRANSLATED"), CHTTPRequest.szPathTranslated, CVTT_STRING>
	CVariable <CStr("REMOTE_HOST"), GetRemoteAddr, CVTT_FUNC>
	CVariable <CStr("REMOTE_ADDR"), GetRemoteAddr, CVTT_FUNC>
	CVariable <CStr("REQUEST_METHOD"), CHTTPRequest.pszMethod, CVTT_LPSTR>
	CVariable <CStr("SCRIPT_NAME"), CHTTPRequest.szFileName, CVTT_STRING>
	CVariable <CStr("SERVER_NAME"), GetServerName, CVTT_FUNC>
	CVariable <CStr("SERVER_SOFTWARE"), GetServerSoftware, CVTT_FUNC>
	CVariable <CStr("SERVER_PORT"), offset g_iPort, CVTT_DWABS>
	CVariable <CStr("SERVER_PROTOCOL"), CHTTPRequest.pszHttpVer, CVTT_LPSTR>
	CVariable <CStr("QUERY_STRING"), CHTTPRequest.pszQueryString, CVTT_LPSTR>
	dd 0

;---------------------------------------------- CMethod

CMethod	struct
pszName LPSTR ?
bType	BYTE  ?
CMethod ends

MethodTab label CMethod
	CMethod <CStr("GET"), HTTP_GET>
	CMethod <CStr("POST"), HTTP_POST>
	CMethod <CStr("HEAD"), HTTP_HEAD>
SIZEMETHODTAB equ ($ - MethodTab) / sizeof CMethod

;---------------------------------------------- CHeader

CHeader struct
pszName	LPSTR ?
pfn		DWORD ?
CHeader ends

HeaderTab label CHeader
	CHeader <CStr("Host:"), GetHostName>
	CHeader <CStr("Connection:"), GetConnection>
	CHeader <CStr("Content-Length:"), GetContentLength>
	CHeader <CStr("Content-Type:"), GetContentType>
	CHeader <CStr("If-Modified-Since:"), GetIfModifiedSince>
SIZEHEADERTAB equ ($ - HeaderTab) / sizeof CHeader

;---------------------------------------------- CStatus

CStatus		struct
dwStatus	DWORD ?
pszStatus	LPSTR ?
pszText		LPSTR ?
CStatus		ends

StatusTab	label CStatus
sOK	CStatus <HTTP_STATUS_OK,			CStr("OK"),				NULL>
sOM	CStatus <HTTP_STATUS_REDIRECT,		CStr("Object Moved"),	NULL>
sNM	CStatus <HTTP_STATUS_NOT_MODIFIED,	CStr("Not Modified"),	NULL>
	CStatus <HTTP_STATUS_BAD_REQUEST,	CStr("Bad Request"),	offset szBody400>
	CStatus <HTTP_STATUS_FORBIDDEN,		CStr("Forbidden"),		offset szBody403>
	CStatus <HTTP_STATUS_NOT_FOUND,		CStr("File not found"), offset szBody404>
	CStatus <HTTP_STATUS_URI_TOO_LONG,	CStr("URI too long"),	offset szBody414>
	CStatus <HTTP_STATUS_NOT_SUPPORTED, CStr("Not Supported"),	offset szBody501>
	CStatus <HTTP_STATUS_SERVER_ERROR,	CStr("Server error"),	offset szBody500>
SIZESTATUSTAB equ ($ - StatusTab) / sizeof CStatus

;---------------------------------------------- MimeTab

;--- every entry in MimeExt MUST have a correspondent entry in MimeTranslation

MimeExt	label dword
	dd ".htm", "html", ".xml", ".css"
	dd ".zip", ".gif", ".jpg", "jpeg", ".png", ".mid", ".wav"
MIMETABSIZE equ $ - MimeExt
MIMETABENTRIES equ MIMETABSIZE / sizeof DWORD

MimeTranslation	label dword
	dd CStr("text/html", szTextHtml)
	dd offset szTextHtml
	dd CStr("text/xml")
	dd CStr("text/css")
	dd CStr("application/x-zip-compressed")
	dd CStr("image/gif")
	dd CStr("image/jpeg", szImageJpeg)
	dd offset szImageJpeg
	dd CStr("image/png")
	dd CStr("audio/mid")
	dd CStr("audio/wav")
if ($ - MimeTranslation) ne MIMETABSIZE 
     %out error: tabs MimeExt and MimeTranslation don't have same size
	.err
endif
	dd CStr("text/plain")	;this entry is the "default", dont delete

;---------------------------------------------- strings

szHTTP1_0		db	'HTTP/1.0',0
szHTTP1_1		db	'HTTP/1.1',0

szIndexFile		db	"index.html",0

szGenericHead	db	"%s %i %s",13,10
				db	"Date: %s",13,10
				db	"Content-Type: %s",13,10
				db	"Content-Length: %i",13,10
				db	13,10,0
szGenericHead2	db	"%s %i %s",13,10
				db	"Date: %s",13,10
				db	"Content-Type: %s",13,10
				db	"Content-Length: %i",13,10
				db	"Last-Modified: %s",13,10
				db	13,10,0
szHeadNotMod	db	"%s %i %s",13,10
				db	"Date: %s",13,10
				db	13,10,0

szBody302		db	"<head><title>Document Moved</title></head>"
				db	"<body><h1>Object Moved</h1>This document may be found "
				db	"<a HREF=", 22h, "%s", 22h, ">here</a></body></html>",0

szBodyXXX		db	"<html><title>Error %u</title><body><b>%u %s</b><br><br>%s</body></html>",0

szBody400		db	"The request wasn't understood by the server",0
szBody403		db	"Hey You, stop snoopin'!",0
szBody404		db	"The file couldn't be found. Whatever. "
				db	"It was probably no good anyway.",0
szBody414		db	"Requested URI is too long",0
szBody500		db	"Internal server error",0
szBody501		db	"Request not supported",0


	.code


SendHeader proc

	mov eax, m_pszHeaderOut
;---------------------------------- only send header if HTTP version is specified
	.if (eax && byte ptr [eax] > ' ')
		DebugOut "SendHeader %s", m_pszHeaderOut
		invoke	send, m_hSocket, m_pszHeaderOut, m_dwSizHeader, 0
if ?USEINTERLOCKED
		invoke InterlockedExchangeAdd, addr g_dwBytesSent, eax
else
		add g_dwBytesSent, eax
endif
	.endif
	mov m_bHeaderSent, TRUE
	ret
	align 4

SendHeader endp

;*** this method does all the send (except header)
;*** buffering is currently handled by JASP ISAPI extension

Send proc this_:ptr CHTTPRequest,pBuffer:LPSTR, dwSize:DWORD
	
if ?BUFFEREDOUT
	.if (m_bBuffered)
		.if (!m_pBufferOut)
			invoke malloc, ?BUFSIZOUT	;use a 256 kB default buffer size
			mov m_pBufferOut, eax
			mov m_dwFreeOut, ?BUFSIZOUT
		.endif
		pushad
		mov ecx,dwSize
		.if (ecx > m_dwFreeOut)
			mov eax,m_dwConLenOut
			add eax,ecx
			and eax, not ?BUFSIZOUT-1
			add eax,?BUFSIZOUT
			mov edx, eax
			sub eax, m_dwConLenOut
			mov m_dwFreeOut, eax
			push ecx
			invoke HeapReAlloc, g_hHeap, 0, m_pBufferOut, edx
			.if (!eax)
				invoke RaiseException, STATUS_NO_MEMORY, \
					EXCEPTION_NONCONTINUABLE, NULL, NULL
			.endif
			mov m_pBufferOut, eax
			pop ecx
		.endif
		mov eax,m_pBufferOut
		add eax,m_dwConLenOut
		add m_dwConLenOut, ecx
		sub m_dwFreeOut, ecx
		mov edi,eax
		mov esi,pBuffer
		mov dl,cl
		shr ecx,2
		rep movsd
		mov cl,dl
		and cl,3
		rep movsb
		popad
		mov eax, dwSize
	.else
endif
		.if (m_bHeaderSent == FALSE)
			invoke SendHeader
		.endif
		invoke	send, m_hSocket, pBuffer, dwSize, 0
if ?USEINTERLOCKED
		invoke InterlockedExchangeAdd, addr g_dwBytesSent, eax
else
		add g_dwBytesSent, eax
endif
if ?BUFFEREDOUT
	.endif
endif
	ret
	align 4
Send endp


;*** get request type (GET/POST), requested file + HTTP version
;*** GET /xxx HTTP/1.1


GetHTTPMethod proc uses esi edi this_:ptr CHTTPRequest, pszLine:LPSTR

local	dwSize:DWORD

	mov m_pszActionParam, CStr("")

	mov ecx,pszLine
	.while (byte ptr [ecx] > ' ')
		inc ecx
	.endw
	sub ecx, pszLine
	mov dwSize, ecx

	mov edx, offset MethodTab
	mov ecx, SIZEMETHODTAB
	.while (ecx)
		push ecx
		mov	esi,pszLine
		mov edi, [edx].CMethod.pszName
		mov ecx, dwSize
		repz cmpsb
		pop ecx
		.if (ZERO? && byte ptr [edi] == 0)
			mov al,[edx].CMethod.bType
			mov m_Action, al
			mov edx,[edx].CMethod.pszName
			mov m_pszMethod, edx
			.break
		.endif
		dec ecx
		add edx, sizeof CMethod
	.endw

	.if (!ecx)
		mov	m_Action,HTTP_UNKNOWN
		.if (g_bLogRequests)
			invoke printf, CStr("%s - unknown method"), pszLine
		.endif
		mov esi, pszLine
		mov m_pszMethod, esi
		add esi, dwSize
		mov byte ptr [esi],0
	.endif

	.if (byte ptr [esi] != ' ')
		ret
	.endif
	inc esi

	mov m_pszActionParam, esi
	.while (byte ptr [esi] > ' ')
		inc esi
	.endw

	.if	(BYTE ptr [esi])			;More after URI -> HTTP version number
		mov byte ptr [esi],0
		inc esi
		mov ecx,esi
		.while (byte ptr [ecx] > ' ')
			inc ecx
		.endw
		sub ecx, esi
		mov dwSize, ecx
		mov pszLine, esi
		mov edi, offset szHTTP1_1
		repz cmpsb
		.if (ZERO? && byte ptr [edi] == 0)
			mov	m_pszHttpVer, offset szHTTP1_1
			or  m_dwFlags, HF_HTTP11_REQUEST
			mov m_bKeepAlive, TRUE
		.else
			mov edi, offset szHTTP1_0
			mov esi, pszLine
			mov ecx, dwSize
			repz cmpsb
			.if (ZERO? && byte ptr [edi] == 0)
				mov	m_pszHttpVer, offset szHTTP1_0
			.endif
		.endif
	.endif
	ret
	align 4

GetHTTPMethod endp

;--- some small scan functions called by GetHTTPNextParam
;--- esi -> header, ebx = this, edi can be modified

GetHostName:
		or		m_dwFlags, HF_HOST_SUPPLIED
		invoke	GetValue, addr m_szHost, esi, sizeof CHTTPRequest.szHost
		ret
GetConnection:
		invoke _memicmp, esi, CStr("Keep-Alive"), 10
		.if (!eax)
			mov m_bKeepAlive, TRUE
			ret
		.endif
		invoke _memicmp, esi, CStr("close"), 5
		.if (!eax)
			mov m_bKeepAlive, FALSE
			ret
		.endif
		ret
GetContentLength:
		invoke	String2Number, esi, addr m_dwConLenIn, 10
		ret
GetContentType:
		invoke	GetValue, addr m_szContType, esi, sizeof CHTTPRequest.szContType
		ret
GetIfModifiedSince:
		invoke	GetValue, addr m_szIfModifiedSince, esi, sizeof CHTTPRequest.szIfModifiedSince
		ret


;--- scan a header line


GetHTTPNextParm proc uses esi edi this_:ptr CHTTPRequest, pszLine:LPSTR

local	dwSize:DWORD

	mov	esi,pszLine
	mov ecx, esi
	.while (byte ptr [ecx] > ' ')
		inc ecx
	.endw
	sub ecx, pszLine
	mov dwSize, ecx
	mov edx, offset HeaderTab
	mov ecx, SIZEHEADERTAB
	.while (ecx)
		push ecx
		mov edi,[edx].CHeader.pszName
		mov ecx, dwSize
		mov esi, pszLine
		.while (ecx)
			lodsb
			mov ah,[edi]
			inc edi
			or al,20h
			or ah,20h
			cmp al,ah
			.break .if (!ZERO?)
			dec ecx
		.endw
		pop ecx
		.if (ZERO? && byte ptr [edi] == 0)
			.if (byte ptr [esi] == ' ')
				inc esi
			.endif
			call [edx].CHeader.pfn
			.break
		.endif
		dec ecx
		add edx, sizeof CHeader
	.endw
	ret
	align 4

GetHTTPNextParm endp


;--- Get a (header) value, now simply a strcpyn function


GetValue proc uses edi esi pszDest:LPSTR, pszSrc:LPSTR, maxLen:DWORD

	mov		esi,pszSrc
	mov		edi,pszDest
	mov		ecx,maxLen
	mov		al, 1
	.while (al && ecx)
		lodsb
		stosb
		dec ecx
	.endw
	ret				
	align 4

GetValue endp


;--- GetServerVariable functions
;--- edi -> output buffer, edx -> size
;--- ebx -> this_
;--- esi -> buffer with size 256
;--- esi & edi can be used here

;--- GetServerVariable(SERVER_NAME)

GetServerName	proc
	invoke gethostname, esi, 256
	ret
	align 4

GetServerName	endp

GetRemoteAddr	proc

local remote_sa:sockaddr_in
local dwSize:DWORD

	mov dwSize, sizeof sockaddr_in
	invoke getpeername, m_hSocket, addr remote_sa, addr dwSize
	.if (!eax)
		push edi
		movzx ecx, remote_sa.sin_addr.S_un.S_un_b.s_b1
		movzx edx, remote_sa.sin_addr.S_un.S_un_b.s_b2
		movzx edi, remote_sa.sin_addr.S_un.S_un_b.s_b3
		movzx eax, remote_sa.sin_addr.S_un.S_un_b.s_b4
		invoke wsprintf, esi, CStr("%u.%u.%u.%u"), ecx, edx, edi, eax
		pop edi
	.endif
	ret
GetRemoteAddr	endp

;--- GetServerVariable(SERVER_SOFTWARE)

GetServerSoftware	proc

	mov eax,g_dwVersion
	movzx ecx,ax
	shr eax,16
	invoke wsprintf, esi, CStr("%s %u.%u"), addr g_szServerName, eax, ecx
	ret
	align 4

GetServerSoftware	endp

;--- GetServerVariable(ALL_HTTP)
;--- this may return a rather large string which cannot be saved in
;--- preallocated buffer.
;--- Important: format of this var is:
;--- <var name>:<value>LF<var name>:<value>LF<Null>

GetAllHttp	proc uses edi

local pszTemp:LPSTR

	mov edi, esi
	mov pszTemp, edi
	mov byte ptr [edi],0
	mov esi,m_pszHeaderIn
	xor ecx, ecx				;count bytes we need
	.if (esi)
		.while (byte ptr [esi])
			add ecx, 6			;"HTTP_" + LF
			lodsb
			.while (al)
				inc ecx
				lodsb
			.endw
			.if (byte ptr [esi] == 10)
				inc esi
			.endif
		.endw
		inc ecx					;terminating 0
		.if (ecx > 512)
			invoke malloc, ecx
			mov edi, eax
			mov pszTemp, eax
		.endif

		mov esi,m_pszHeaderIn
		.while (byte ptr [esi])
			mov eax, "HTTP"
			bswap eax
			stosd
			mov al,'_'
			stosb
			lodsb
			mov ah,01
			.while (al)
				.if (ah)
					.if (al > 60h)	;transform var name to caps
						and al, 0DFh
					.elseif (al == '-')
						mov al,'_'
					.elseif (al == ':')
						mov ah,00
						.if (byte ptr [esi] == ' ')
							inc esi
						.endif
					.endif
				.endif
				stosb
				lodsb
			.endw
			mov al, 10
			stosb
			.if (byte ptr [esi] == 10)
				inc esi
			.endif
		.endw
		mov byte ptr [edi],0
	.endif
	mov esi, pszTemp
	ret
	align 4

GetAllHttp	endp

;--- check if call supplied buffer is large enough
;--- edx -> ptr maxSize
;--- esi -> variable
;--- returns -1 if buffer to small or bytes to copy

CheckBufferSize	proc uses esi
	xor ecx, ecx
	.repeat
		lodsb
		inc ecx
	.until (!al)
	mov eax, ecx
	mov ecx,[edx]
	mov [edx], eax
	.if (eax > ecx)
		invoke SetLastError, ERROR_INSUFFICIENT_BUFFER
		return -1
	.endif
	ret
CheckBufferSize	endp


;--- ISAPI callback GetServerVariable
;--- on output, set 


_GetServerVariable proc uses esi edi __this this_:ptr CHTTPRequest, lpszVariableName:LPSTR,
		lpvBuffer:LPVOID, lpdwSizeOfBuffer:LPDWORD

	local	pszBuffer:LPSTR
	local	dwLength:DWORD
	local	szBuffer[512]:byte

	DebugOut "Httpd: GetServerVariable(%s)", lpszVariableName

	mov __this,this_

	mov ecx,lpszVariableName
	mov eax,[ecx]
;---------------------------------------- get the HTTP_ vars
	.if (eax == "PTTH" && byte ptr [ecx+4] == '_')
		add ecx, 5
		mov lpszVariableName, ecx
		invoke lstrlen, ecx
		mov dwLength, eax
		mov esi, m_pszHeaderIn
		.while (byte ptr [esi])
			mov ecx,dwLength
			.if (byte ptr [esi+ecx] == ':')
				mov edi, lpszVariableName
				.while (ecx)
					lodsb
					mov ah, [edi]
					inc edi
					.if (al == '-')
						mov al,'_'
					.elseif (al > 60h)
						and al, 0DFh
					.endif
					.break .if (al != ah)
					dec ecx
				.endw
				.if (!ecx)
					inc esi					;skip ':'
					.if (byte ptr [esi] == ' ')
						inc esi
					.endif
					mov edx,lpdwSizeOfBuffer
					invoke CheckBufferSize
					.if (eax == -1)
						return FALSE
					.endif
					mov ecx,eax
					mov edi,lpvBuffer
					rep movsb
					return TRUE
				.endif
			.endif
			lodsb
			.while (al)
				lodsb
			.endw
			.if (byte ptr [esi] == 0Ah)
				inc esi
			.endif
		.endw
	.endif

	mov esi,offset VarTab
	.while ([esi].CVariable.pszName)
		invoke lstrcmp, [esi].CVariable.pszName, lpszVariableName
		.if (!eax)
			mov pszBuffer, NULL
			mov edi, lpvBuffer
			mov ecx,[esi].CVariable.dwOffset
			mov edx,lpdwSizeOfBuffer
			mov al, [esi].CVariable.bType
			.if (al == CVTT_LPSTR || al == CVTT_STRING)
				.if (al == CVTT_LPSTR)
					mov esi,[__this][ecx]
				.else
					lea esi,[__this][ecx]
				.endif
			.elseif (al == CVTT_DWORD || al == CVTT_DWABS)
				.if (al == CVTT_DWABS)
					mov eax,[ecx]
				.else
					mov eax,[__this][ecx]
				.endif
				lea esi, szBuffer
				invoke wsprintf, esi, CStr("%u"), eax
			.elseif (al == CVTT_FUNC)
				lea esi, szBuffer
				call ecx
				lea eax, szBuffer
				.if (esi != eax)
					mov pszBuffer, esi
				.endif
			.endif
;-------------------------------- here esi should point to ASCIIZ source string
			mov edx,lpdwSizeOfBuffer
			invoke CheckBufferSize
			DebugOut "Httpd: GetServerVariable()=%u [%.128s]", eax, esi
			push eax
			.if (eax != -1)
				mov ecx,eax
				rep movsb
			.endif
			.if (pszBuffer)
				invoke free, pszBuffer
			.endif
			pop eax
			.if (eax == -1)
				return FALSE
			.else
				return TRUE
			.endif
		.endif
		add esi, sizeof CVariable
	.endw
	invoke SetLastError, ERROR_INVALID_INDEX
	return FALSE
	align 4

_GetServerVariable endp


_WriteClient proc uses __this this_:ptr CHTTPRequest, lpBuffer:LPVOID, lpdwBytes:ptr DWORD, dwReserved:DWORD

	DebugOut "Httpd: WriteClient(%.80s)", lpBuffer
	mov __this,this_
	mov eax,lpdwBytes
	mov eax,[eax]
	invoke	Send, __this, lpBuffer, eax
	mov ecx,lpdwBytes
	mov [ecx],eax
	ret
	align 4

_WriteClient endp


_ReadClient proc uses __this this_:ptr CHTTPRequest, lpvBuffer:LPVOID, lpdwSize:ptr DWORD

	DebugOut "Httpd: ReadClient"
	mov __this,this_
	mov eax,lpdwSize
	mov eax,[eax]
	invoke	recv, m_hSocket, lpvBuffer, eax, 0
	.if (eax == SOCKET_ERROR)
		return FALSE
	.endif
ifdef _DEBUG
	mov edx, lpvBuffer
    mov byte ptr [edx+eax],0
	DebugOut <"bytes: %s",13,10>, edx
endif
	mov ecx,lpdwSize
	mov [ecx],eax
	return TRUE
	align 4

_ReadClient endp


;--- ServerSupportFunction, HSE_REQ_TRANSMIT_FILE
;--- edi -> HSE_TF_INFO, ebx == __this

SupportFunctionTransmitFile proc

local tfb:TRANSMIT_FILE_BUFFERS
local szHeader[1024]:byte

	assume edi:ptr HSE_TF_INFO
	mov eax,[edi].pfnHseIO
	.if (eax)
		mov m_pfnIOCompletion, eax
	.endif
	.if (!m_pfnIOCompletion)
		xor eax,eax
		jmp done
	.endif
	mov eax,[edi].pContext
	mov m_pContext, eax

	mov eax,[edi].dwFlags
	xor ecx,ecx
	xor edx,edx
	.if (eax & HSE_IO_SEND_HEADERS)
		mov eax,m_pszHttpVer
		.if (byte ptr [eax] == 0)
		.elseif ([edi].pszStatusCode)
			invoke wsprintf, addr szHeader, CStr(<"%s %s",13,10,"%s">),\
					m_pszHttpVer, [edi].pszStatusCode, [edi].pHead
			lea ecx, szHeader
			mov edx, eax
		.else
			mov ecx, [edi].pHead
			mov edx, [edi].HeadLength
		.endif
	.endif
	mov tfb.Head, ecx
	mov tfb.HeadLength, edx
	mov ecx, [edi].pTail
	mov edx, [edi].TailLength
	mov tfb.Tail, ecx
	mov tfb.TailLength, edx

	mov ecx,[edi].Offset_
	mov m_overlapped.Offset_, ecx
	mov m_overlapped.OffsetHigh, 0
	invoke WSACreateEvent
	mov m_overlapped.hEvent, eax

	mov ecx, 0
	.if (eax & HSE_IO_DISCONNECT_AFTER_SEND)
		mov ecx, TF_DISCONNECT
	.endif
	.if (g_lpfnTransmitFile)
		invoke g_lpfnTransmitFile, m_hSocket, [edi].hFile, [edi].BytesToWrite,\
			0, addr m_overlapped, addr tfb, ecx
		mov eax,1
	.else
		invoke SimTransmitFile, __this, [edi].hFile, [edi].BytesToWrite, addr tfb
	.endif
done:
	ret
	align 4
	assume edi:nothing

SupportFunctionTransmitFile endp


;--- ISAPI callback ServerSupportFunction


_ServerSupportFunction proc uses __this edi this_:ptr CHTTPRequest, dwHSERequest:DWORD, lpvBuffer:LPVOID, lpdwSize:ptr DWORD, lpdwDataType:LPDWORD

local bRC:BOOL
local szText[512]:byte

	DebugOut "Httpd: ServerSupportFunction(%u)", dwHSERequest

	mov __this,this_

	mov bRC, TRUE
	mov eax,dwHSERequest
	mov edi,lpvBuffer

	.if (eax == HSE_REQ_SEND_URL)			;2

		invoke wsprintf, addr szText, addr szBody302, edi
		mov m_dwConLenOut, eax
		lea edx, sOM
		invoke wsprintf, m_pszHeaderOut,\
			CStr(<"%s %u %s",13,10,"Location: %s",13,10, "Content-Type: %s",13,10,"Content-Length: %u",13,10,13,10>),\
				m_pszHttpVer, HTTP_STATUS_REDIRECT, [edx].CStatus.pszStatus,\
				edi, addr szTextHtml, m_dwConLenOut
		mov m_dwSizHeader, eax
		invoke Send, __this, addr szText, m_dwConLenOut

	.elseif (eax == HSE_REQ_SEND_RESPONSE_HEADER)	;3	

		.if (!edi)
			mov edi, CStr("200 OK")
		.endif
		mov ecx, lpdwDataType
		.if (!ecx)
			mov ecx, CStr(<13,10>)
		.endif
		invoke wsprintf, m_pszHeaderOut, CStr(<"%s %s",13,10,"%s">),\
				m_pszHttpVer, edi, ecx
		mov m_dwSizHeader, eax
		invoke SendHeader

	.elseif (eax == HSE_REQ_DONE_WITH_SESSION)	;4

	.elseif (eax == HSE_REQ_MAP_URL_TO_PATH)	;1001 MS specific

		mov eax,lpdwSize
		mov eax, [eax]
		invoke TranslateUrl, edi, edi, eax
;		invoke TranslateUrl, CStr("/perl/example.pl"), edi, eax
		mov ecx,lpdwSize
		mov [ecx],eax

	.elseif (eax == HSE_APPEND_LOG_PARAMETER)	;1003 MS specific

		invoke printf, CStr("%s"), edi

	.elseif (eax == HSE_REQ_IO_COMPLETION)		;1005 MS specific

		mov m_pfnIOCompletion, edi

	.elseif (eax == HSE_REQ_TRANSMIT_FILE)		;1006 MS specific

		invoke SupportFunctionTransmitFile
		mov bRC, eax

	.elseif (eax == HSE_REQ_IS_KEEP_CONN)		;1008 MS specific

		movzx eax,m_bKeepAlive
		mov [edi],eax

	.elseif (eax == HSE_REQ_SEND_RESPONSE_HEADER_EX)	;1016 MS specific

		assume edi:ptr HSE_SEND_HEADER_EX_INFO

		push esi
		mov esi, m_pszHttpVer
		invoke lstrlen, esi
		mov edx, edi
		mov edi, m_pszHeaderOut
		mov ecx, eax
		rep movsb
		mov al, ' '
		stosb
		mov ecx, [edx].HSE_SEND_HEADER_EX_INFO.cchStatus
		.if (ecx)
			mov esi, [edx].HSE_SEND_HEADER_EX_INFO.pszStatus
			.if (ecx == -1)
				push edx
				invoke lstrlen, esi
				pop edx
				mov ecx, eax
			.endif
		.else
			mov esi, CStr("200 OK")
			mov ecx, 6
		.endif
		rep movsb
		mov ax, 0A0DH
		stosw
				
		mov ecx, [edx].HSE_SEND_HEADER_EX_INFO.cchHeader
		.if (ecx)
			mov esi, [edx].HSE_SEND_HEADER_EX_INFO.pszHeader
			.if (ecx == -1)
				push edx
				invoke lstrlen, esi
				pop edx
				mov ecx, eax
			.endif
		.else
			mov esi, CStr(<13,10>)
			mov ecx, 2
		.endif
		rep movsb
		mov al, 00
		mov [edi],al
		sub edi, m_pszHeaderOut	
		mov m_dwSizHeader, edi
		mov edi, edx
		pop esi

		invoke SendHeader

		mov eax,[edi].fKeepConn
		mov m_bKeepAlive, al
		assume edi:nothing

	.else
		mov bRC, FALSE
	.endif
done:
	return bRC
	align 4

_ServerSupportFunction endp

;--- send an error header + body

SendError proc uses edi this_:ptr CHTTPRequest

	LOCAL	_st:SYSTEMTIME
	LOCAL	dwSizeBody:DWORD
	LOCAL	szBody[512]:byte
	LOCAL	szTime[32]:byte

	DebugOut "SendError"
	mov eax, m_dwCode
	mov edi, offset StatusTab
	mov ecx, SIZESTATUSTAB
	.while (ecx > 1)			;last entry is default setting
		.break .if (eax == [edi].CStatus.dwStatus)
		add edi, sizeof CStatus
		dec ecx
	.endw

	invoke	wsprintf, addr szBody, addr szBodyXXX, m_dwCode, m_dwCode,\
		[edi].CStatus.pszStatus, [edi].CStatus.pszText
	mov		dwSizeBody, eax

	invoke	GetSystemTime, addr _st
	invoke	InternetTimeFromSystemTime, addr _st, INTERNET_RFC1123_FORMAT,\
		addr szTime, sizeof szTime
	invoke	wsprintf, m_pszHeaderOut, addr szGenericHead,\
			m_pszHttpVer, m_dwCode, [edi].CStatus.pszStatus,\
			addr szTime, addr szTextHtml, dwSizeBody
	mov		m_dwSizHeader, eax
	invoke	Send, __this, addr szBody, dwSizeBody
	ret
	align 4

SendError endp



SearchISAPI proc pszName:LPSTR

	invoke EnterCriticalSection, addr g_cs
	mov ecx,g_pISAPI
	.while (ecx)
		push ecx
		invoke lstrcmpi, pszName, [ecx].CIsapi.pszName  
		pop ecx
		.break .if (!eax)
		mov ecx,[ecx].CIsapi.pNext
	.endw
	mov eax,ecx
	.if (!eax)
		invoke LoadISAPIExtension, pszName, 0
	.endif
	push eax
	invoke LeaveCriticalSection, addr g_cs
	pop eax
	ret
	align 4

SearchISAPI endp


CallIsapi	proc this_:ptr CHTTPRequest, pISAPI:ptr CIsapi

	LOCAL	pHEP:PFN_HTTPEXTENSIONPROC
	LOCAL	dwNumBytes:DWORD
	LOCAL	dwFlags:DWORD
	LOCAL	ecb:EXTENSION_CONTROL_BLOCK

	DebugOut "CallIsapi"
	mov eax,pISAPI
	.if (!eax)
		invoke	SearchISAPI, addr m_szFullPath
		.if (!eax)
			mov		m_dwCode,HTTP_STATUS_SERVER_ERROR
			jmp		exit
		.endif
	.endif

	mov ecx,[eax].CIsapi.pHEP
	mov pHEP,ecx

	mov ecb.cbSize, sizeof EXTENSION_CONTROL_BLOCK
	mov ecb.dwVersion, HSE_VERSION
	mov ecb.ConnID, __this
	mov ecb.dwHttpStatusCode, 0
	mov ecb.lpszLogData, 0
	mov eax, m_pszMethod
	mov ecb.lpszMethod, eax
	mov eax, m_pszQueryString
	mov ecb.lpszQueryString, eax
	lea eax, m_szPathInfo
	mov ecb.lpszPathInfo, eax
if 1	;?TESTFULLPATH
	lea eax, m_szPathTranslated
else
	.if (pISAPI)
		lea eax, m_szFullPath
	.else
		lea eax, m_szPathTranslated
	.endif
endif
	mov ecb.lpszPathTranslated, eax
	mov eax, m_dwConLenIn
	mov ecb.cbTotalBytes, eax
	mov eax, m_dwReadIn
	mov ecb.cbAvailable, eax
	mov eax, m_pszBodyIn
	mov ecb.lpbData, eax
	mov ecb.lpszContentType, NULL
	mov ecb.GetServerVariable, _GetServerVariable
	mov ecb.WriteClient, _WriteClient
	mov ecb.ReadClient, _ReadClient
	mov ecb.ServerSupportFunction, _ServerSupportFunction
	DebugOut "CallIsapi, lpszQueryString=%.80s", ecb.lpszQueryString
	DebugOut "CallIsapi, lpszPathInfo=%.80s", ecb.lpszPathInfo
	DebugOut "CallIsapi, lpszPathTranslated=%.80s", ecb.lpszPathTranslated
	invoke pHEP, addr ecb
	.if (eax == HSE_STATUS_SUCCESS)
		mov m_bKeepAlive, FALSE
	.elseif (eax == HSE_STATUS_SUCCESS_AND_KEEP_CONN)
		;
	.elseif (eax == HSE_STATUS_PENDING)
		.if (m_overlapped.hEvent)
			.if (g_lpfnWSAGetOverlappedResult)
				invoke g_lpfnWSAGetOverlappedResult, m_hSocket, addr m_overlapped,\
					addr dwNumBytes, TRUE, addr dwFlags
				mov eax,dwNumBytes
if ?USEINTERLOCKED
				invoke InterlockedExchangeAdd, addr g_dwBytesSent, eax
else
				add g_dwBytesSent, eax
endif
;				invoke WSAWaitForMultipleEvents, 1, addr m_overlapped.hEvent,\
;					FALSE, INFINITE, TRUE
			.endif
			invoke WSACloseEvent, m_overlapped.hEvent
			invoke m_pfnIOCompletion, addr ecb, m_pContext, 0, 0
		.endif
	.else
		mov eax,ecb.dwHttpStatusCode
		mov m_dwCode, eax
	.endif
exit:
	ret
CallIsapi	endp


;--- Win9x doesnt support TransmitFile. So simulate this here
;--- its not quite identical. counter g_dwBytesSent is updated here!


SimTransmitFile proc this_:ptr CHTTPRequest, hFile:DWORD, dwFileSize:DWORD, ptfn:ptr TRANSMIT_FILE_BUFFERS

	LOCAL	dwRead:DWORD
	LOCAL	pBuffer:LPSTR

	.if (!dwFileSize)
		invoke	GetFileSize, hFile, 0
		mov		dwFileSize,eax
	.endif
if ?USEVIRTALLOC
	invoke VirtualAlloc, NULL, dwFileSize, MEM_COMMIT, PAGE_READWRITE
else
	invoke	malloc, dwFileSize
endif
	.if (!eax)
		invoke printf, CStr("memory error!!!")
		mov	m_dwCode,HTTP_STATUS_SERVER_ERROR
		xor eax,eax
		jmp	exit
	.endif
	mov pBuffer,eax

	invoke ReadFile, hFile, pBuffer, dwFileSize, addr dwRead, 0
	mov ecx,dwRead
	.if (eax && (ecx == dwFileSize))
		mov eax,ptfn
		mov ecx,[eax].TRANSMIT_FILE_BUFFERS.Head
		mov m_pszHeaderOut, ecx
		mov ecx,[eax].TRANSMIT_FILE_BUFFERS.HeadLength
		mov	m_dwSizHeader, ecx
		invoke Send, __this, pBuffer, dwFileSize
	.else
		invoke printf, CStr("file read error!!!")
		mov	m_dwCode,HTTP_STATUS_NOT_FOUND
		xor eax,eax
	.endif
	push eax
if ?USEVIRTALLOC
	invoke VirtualFree, pBuffer, 0, MEM_RELEASE
else
	invoke free, pBuffer
endif
	pop eax
exit:
	ret
	align 4

SimTransmitFile endp


;--- get MIME Content-Type from file extension


GetMIMEType	proc uses edi

	mov ecx,MIMETABENTRIES
	mov eax, m_dwExtension
	bswap eax
	mov edi,offset MimeExt
	repnz scasd
	.if (ZERO?)
		sub edi, sizeof DWORD
	.endif
	mov eax,[edi+MIMETABSIZE]
	ret

GetMIMEType endp


;*** transfer file to client


FileTransfer	proc this_:ptr CHTTPRequest

	LOCAL	hFile:DWORD
	LOCAL	dwSizeHead:DWORD
	LOCAL	dwFileSize:DWORD
	local	ft:FILETIME
	local	ft2:FILETIME
	local	_st:SYSTEMTIME
	local	szTime[32]:byte
	LOCAL	tfb:TRANSMIT_FILE_BUFFERS

;-------------------------------- Sequential read->File reads faster, sequentially
	invoke	CreateFile, addr m_szFullPath, GENERIC_READ, FILE_SHARE_READ,\
					0, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0
	.if (eax == INVALID_HANDLE_VALUE)
		mov		m_dwCode,HTTP_STATUS_NOT_FOUND
		jmp		exit
	.endif
	mov		hFile,eax
	invoke	GetFileSize, hFile, 0
	mov		dwFileSize,eax
	mov		m_dwCode, HTTP_STATUS_OK
	invoke	GetFileTime, hFile, NULL, NULL, addr ft
	invoke	FileTimeToSystemTime, addr ft, addr _st 
	invoke	InternetTimeFromSystemTime, addr _st, INTERNET_RFC1123_FORMAT,\
		addr m_szLastModified, sizeof CHTTPRequest.szLastModified
	.if (m_szIfModifiedSince)
		invoke InternetTimeToSystemTime, addr m_szIfModifiedSince,\
			addr _st, 0
		invoke SystemTimeToFileTime, addr _st, addr ft2
		invoke CompareFileTime, addr ft, addr ft2
		.if (eax != 1)
			mov m_dwCode, HTTP_STATUS_NOT_MODIFIED
		.endif
	.endif
	invoke	GetMIMEType
	mov m_pszContTypeOut, eax

	invoke	GetSystemTime, addr _st
	invoke	InternetTimeFromSystemTime, addr _st, INTERNET_RFC1123_FORMAT,\
		addr szTime, sizeof szTime

	.if (m_dwCode == HTTP_STATUS_NOT_MODIFIED)
		lea edx, sNM
		invoke wsprintf, m_pszHeaderOut, addr szHeadNotMod,\
				m_pszHttpVer, m_dwCode, [edx].CStatus.pszStatus, addr szTime
	.else
		lea edx, sOK
		invoke wsprintf, m_pszHeaderOut, addr szGenericHead2,\
				m_pszHttpVer, m_dwCode, [edx].CStatus.pszStatus,\
				addr szTime, m_pszContTypeOut, dwFileSize, addr m_szLastModified
	.endif
	mov	m_dwSizHeader, eax
	mov ecx, m_pszHeaderOut
	.if (byte ptr [ecx] > ' ')
		mov tfb.Head, ecx
		mov tfb.HeadLength, eax
	.else
		mov tfb.Head, NULL
		mov tfb.HeadLength, 0
	.endif
	mov tfb.Tail, NULL
	mov tfb.TailLength, 0

	.if (m_Action == HTTP_HEAD || m_dwCode == HTTP_STATUS_NOT_MODIFIED)
		invoke SendHeader
	.elseif (g_lpfnTransmitFile)
		invoke g_lpfnTransmitFile, m_hSocket, hFile, 0, 0, 0, addr tfb, 0
		.if (eax)
			mov eax,dwFileSize
			add eax,m_dwSizHeader
if ?USEINTERLOCKED
			invoke InterlockedExchangeAdd, addr g_dwBytesSent, eax
else
			add g_dwBytesSent, eax
endif
if 0
			invoke printf, CStr("%u total bytes sent"), g_dwBytesSent
		.else
			invoke WSAGetLastError
			.if (eax == ERROR_IO_PENDING)
				mov eax,dwFileSize
				add eax,m_dwSizHeader
if ?USEINTERLOCKED
				invoke InterlockedExchangeAdd, addr g_dwBytesSent, eax
else
				add g_dwBytesSent, eax
endif
				invoke printf, CStr("TransmitFile: %u total bytes sent"), g_dwBytesSent
			.else
				invoke printf, CStr("TransmitFile: %u Last Error"), eax
			.endif
endif
		.endif
	.else
		invoke SimTransmitFile, __this, hFile, dwFileSize, addr tfb
	.endif
exit2:
	invoke	CloseHandle,hFile
exit:
	ret
FileTransfer	endp


;*** transmit content to client


ServeContent proc this_:ptr CHTTPRequest

	LOCAL	szHeaderOut[1024]:BYTE

ifdef _DEBUG
	movzx eax, m_Action
	DebugOut "ServeContent enter, action=%u", eax
endif    
	lea		eax,szHeaderOut
	mov		m_pszHeaderOut, eax

	.if	((m_Action == HTTP_GET) || (m_Action == HTTP_POST) || (m_Action == HTTP_HEAD))
;----------------------------------------- HTTP/1.1 req must supply "Host:"
		mov eax, m_dwFlags
		.if (al & HF_HTTP11_REQUEST)
			.if (!(al & HF_HOST_SUPPLIED))
				DebugOut "ServeContent: failed, http1.1 and no host supplied"
				mov		m_dwCode, HTTP_STATUS_BAD_REQUEST
				jmp		doneHTTPGet
			.endif
		.endif

;----------------------------------------- ensure there is no ".." or "C:" in path
		invoke	SafeFilePath, __this
		.if	(!eax)						;File is not safe
			mov		m_dwCode, HTTP_STATUS_FORBIDDEN
			jmp		doneHTTPGet
		.endif
		invoke	ExtractFilename, __this
		.if (!eax)
			mov		m_dwCode, HTTP_STATUS_URI_TOO_LONG	;max URI is 256 here
			jmp		doneHTTPGet
		.endif
		invoke	ScanFilePath, __this
		.if (!eax)
			mov		m_dwCode, HTTP_STATUS_NOT_FOUND		;file not found
			jmp		doneHTTPGet
		.endif
		mov		ecx, m_pszExt
		mov		eax, dword ptr [ecx]
		test eax, 0ff000000h
		.if (ZERO?)
			or		eax,202000h
		.else
			or		eax,20202000h
		.endif
		mov		m_dwExtension, eax
		.if (eax == "lld.")		;extension == .DLL?
			invoke CallIsapi, __this, 0
		.else
			mov ecx,g_pISAPIMapping
			.while (ecx)
				.if ([ecx].CIsapi.pszName == eax)
					invoke CallIsapi, __this, ecx
					mov ecx,-1
					.break
				.endif
				mov ecx,[ecx].CIsapi.pNext
			.endw
			.if (!ecx)
				invoke FileTransfer, __this
			.endif
		.endif
	.elseif	(m_Action == NULL)
		DebugOut "ServeContent: failed, no valid request"
		mov m_dwCode, HTTP_STATUS_BAD_REQUEST
	.elseif (m_Action == HTTP_UNKNOWN)
		mov m_dwCode, HTTP_STATUS_NOT_SUPPORTED
	.else
		movzx eax,m_Action
		invoke printf, CStr("unhandled action %X - programming error"), eax
		mov m_dwCode, HTTP_STATUS_SERVER_ERROR
	.endif		
doneHTTPGet:
	.if (m_dwCode >= HTTP_STATUS_BAD_REQUEST)
		.if (!m_bHeaderSent)
			invoke SendError, __this
		.endif
		mov m_bKeepAlive, FALSE
	.endif
	.if (g_bLogRequests)
		mov ecx,m_pszMethod
		.if (!ecx)
			mov ecx,CStr("???")
		.endif
		invoke printf, CStr("%u - '%s %s'"), m_dwCode, ecx, m_pszActionParam
	.endif
	DebugOut "ServeContent exit"
	ret
	align 4

ServeContent	endp

;--- scan file parameter for "..", ":", "//" or "\" substrings

SafeFilePath proc this_:ptr CHTTPRequest

	mov edx, m_pszActionParam

;------------------------------- abs URLs are allowed
	mov eax,[edx]
	or eax,20202020h
	.if (eax == "ptth")
		mov eax,[edx+4]
		and eax,0FFFFFFh
		.if (eax == "//:")
			or m_dwFlags, HF_ABSOLUTE_PATH
			add edx, 7
			.while (1)
				mov al,[edx]
				.break .if (al == 0 || al == '/')
				inc edx
			.endw
			mov m_pszActionParam, edx	;just throw away "http://" and host
		.endif
	.endif

	xor ecx,ecx
	.while (1)
		mov ch,cl
		mov cl,[edx]
		.break .if ((cl == 0) || (cl == '?'))	;end of file request?
		.if ((cx == '..') || (cx == '//') || (cl == '\') || (cl == ':'))
			return 0
		.endif
		inc	edx
	.endw
	return 1
	align 4

SafeFilePath endp

;--- translate a URL to a physical path
;--- returns size of translated path in EAX

TranslateUrl proc uses esi edi pszIn:LPSTR, pszOut:LPSTR, dwSize:DWORD

local	pszStart:LPSTR

	mov edi, pszOut
;ife ?TESTFULLPATH
if 1
	mov esi, offset g_szRoot
else
	lea esi, m_szPathTranslated
endif
;------------------------------- if (pszIn == pszOut) allocate temp
;------------------------------- buffer on stack
	.if (edi == pszIn)
		smalloc edi, MAX_PATH
	.endif
	mov pszStart, edi
	mov	ecx, dwSize
	mov edx,pszIn
	.while (ecx)
		lodsb
		.if (al == '/')
			mov al,'\'
		.endif
		stosb
		.if (!al)
			.break .if (!edx)
			mov esi,edx
			xor edx,edx
			dec edi
			.continue
		.endif
		dec ecx
	.endw
	sub edi, pszStart
	DebugOut "TranslateUrl(%s, %u)=%u [%s]", pszIn, dwSize, edi, pszStart
	mov eax,pszIn
	.if (eax == pszOut)
		invoke lstrcpyn, pszOut, pszStart, dwSize
		sfree
	.endif
	mov eax, edi
	ret

TranslateUrl endp

;--- scan path until we have a file or get error "not found"
;--- copy from m_szFileName -> m_szFullPath
;--- set m_szPathInfo (PATH_INFO), truncate m_szFileName (SCRIPT_NAME)

ScanFilePath proc uses edi esi this_:ptr CHTTPRequest
	
	LOCAL	LastAttributes:DWORD		;Attributes of the previous item
	LOCAL	nextPath[MAX_PATH]:BYTE

	mov		m_szPathInfo, 0
	mov		m_pszExt,CStr(".htm")

	lea		edi, m_szFullPath
	invoke	lstrcpy, edi, addr g_szRoot
	invoke	lstrlen, edi
	add		edi, eax
	
	lea		esi,m_szFileName
	.while (byte ptr [esi])
		invoke	GetPathElement, esi, addr nextPath
		add		esi,eax
		lea		ecx, m_szFullPath + sizeof CHTTPRequest.szFullPath
		sub		ecx, edi
		.if (eax < ecx)
			mov ecx, eax
		.endif
		push	esi
		lea		esi, nextPath
		rep		movsb
		pop		esi
		invoke	GetFileAttributes, addr m_szFullPath
		test	eax,FILE_ATTRIBUTE_DIRECTORY	;ZF set if nextPath points to a file
		.if (ZERO?)
ife ?TESTFULLPATH
;---------------------------------------- set PATH_INFO
			invoke lstrcpy, addr m_szPathInfo, esi
			DebugOut "ScanFilePath - PATH_INFO = %s", <addr m_szPathInfo>
;---------------------------------------- set PATH_TRANSLATED
			invoke TranslateUrl, addr m_szPathInfo, addr m_szPathTranslated,\
					sizeof CHTTPRequest.szPathTranslated
			DebugOut "ScanFilePath - PATH_TRANSLATED = %s", <addr m_szPathTranslated>
endif
			mov byte ptr [esi],0
			lea eax,[esi-4]
			.if (byte ptr [eax+1] == '.')
				inc eax
			.endif
			mov m_pszExt, eax
			.break
		.endif
		cmp		eax,-1							;see if no such file
		je		ErrorNoSuchFile
	.endw

;------------------------------  empty nextPath:  assume index file is requested
	.if	word ptr [nextPath] == '\'
		invoke	lstrcat,addr m_szFullPath, addr szIndexFile
	.endif
if ?TESTFULLPATH
	invoke lstrcpy, addr m_szPathInfo, addr m_szFileName
	DebugOut "ScanFilePath - PATH_INFO = %s", <addr m_szPathInfo>
	invoke	lstrcpy, addr m_szPathTranslated, addr m_szFullPath
	DebugOut "ScanFilePath - PATH_TRANSLATED = %s", <addr m_szPathTranslated>
endif
	return TRUE
ErrorNoSuchFile:
	return FALSE
	align 4

ScanFilePath endp

;--- copy filename from m_pszActionParam to m_szFileName (SCRIPT_NAME)
;--- translate hex (%xx) chars
;--- set m_pszQueryString (QUERY_STRING)
;--- m_szFileName may be truncated later by PATH_INFO

ExtractFilename	proc uses esi this_:ptr CHTTPRequest

	lea edx,m_szFileName
	mov esi,m_pszActionParam
	mov	ecx,g_dwMaxLen
	mov ah,00
	.while (ecx)
		lodsb
		.break .if ((al == '?') || (al == 0))
		.if (ah)
			call Char2Nib
			dec ah
			.if (ah)
				shl al,4
				mov [edx],al
			.else
				or [edx],al
				dec	ecx
				inc edx
			.endif
		.elseif (al == '%')
			mov ah,02
		.else
			mov [edx],al
			inc edx
			dec	ecx
		.endif
	.endw
	.if (!ecx)
		return 0
	.endif
	mov	BYTE ptr [edx],0
	.if (al == '?')
		mov m_pszQueryString, esi
	.else
		mov m_pszQueryString, CStr("")
	.endif
	return 1
	align 4

ExtractFilename	endp


;*** Returns in pszElementOut the next path element
;*** In eax length of this element


GetPathElement proc uses esi edi pszPathIn:LPSTR, pszElementOut:LPSTR
	
	mov		esi,pszPathIn
	mov		edi,pszElementOut
	lodsb
	.if (al == '/')
		mov al,'\'
		stosb
		lodsb
	.endif
	.while (al && (al != '/'))
		stosb
		lodsb
	.endw
	mov byte ptr [edi],0
	sub edi, pszElementOut
	mov eax, edi
	ret
	align 4

GetPathElement endp


;*** constructor CHTTPRequest: allocates required memory


Create@CHTTPRequest	proc public uses __this hSocket:DWORD

	DebugOut "Create@CHTTPRequest"

	invoke malloc, sizeof CHTTPRequest + ?BUFSIZE
	mov __this,eax

	invoke ZeroMemory, __this, sizeof CHTTPRequest

	mov	eax,hSocket
	mov	m_hSocket,eax

	mov eax,__this
	add eax,sizeof CHTTPRequest
	mov m_pBufferIn, eax

	mov	m_pszHttpVer, CStr("")	;set empty string as default HTTP version

	return __this
	align 4

Create@CHTTPRequest endp

;*** connection is "Keep-Alive", reset CHTTPRequest structure 

ResetRequest	proc uses __this this_:ptr CHTTPRequest

	DebugOut "ResetRequest"

	mov __this,this_

	.if (m_pBufferOut)
		invoke free, m_pBufferOut
		mov m_pBufferOut, NULL
	.endif
	mov ecx, m_pszHeaderOut
	.if (ecx)
		mov byte ptr [ecx], ' '
	.endif
	push m_hSocket
	push m_pBufferIn
	push m_pszHttpVer
	invoke ZeroMemory, __this, sizeof CHTTPRequest
	pop m_pszHttpVer
	pop m_pBufferIn
	pop m_hSocket
	ret
	align 4

ResetRequest	endp

;*** read data from client

GetData@CHTTPRequest proc public uses esi edi __this this_:ptr CHTTPRequest

LOCAL	DataMaxRemain:DWORD
LOCAL	bReused:BOOL

	DebugOut "GetData@CHTTPRequest"

	mov __this,this_

	mov bReused, FALSE

	mov	DataMaxRemain, ?BUFSIZE-1
	mov	esi,m_pBufferIn
	mov edi,esi

	.while (DataMaxRemain)
		invoke	recv, m_hSocket, esi, DataMaxRemain, 0
		.if (eax == SOCKET_ERROR)
			invoke WSAGetLastError
			.if (eax == WSAECONNRESET)				;client shutdown/close, ok
			.elseif (eax == WSAENOTSOCK)			;server closesocket, ok
				mov m_hSocket, INVALID_SOCKET
			.elseif (eax == WSAESHUTDOWN)			;server shutdown, ok
			.else
				invoke printf, CStr("recv() error %u"), eax
			.endif
			.break
		.else
			.break .if (eax == 0)					;socket shut down?
			.if (bReused)
				inc g_dwReusedConnections
				mov bReused, FALSE
			.endif
			add g_dwBytesReceived,eax
			mov byte ptr [esi+eax],0
			mov	ecx,eax
			sub	DataMaxRemain,eax
			.while (ecx)
				mov al,[esi]
;-------------------------------- accept LF, CR, CR+LF or LF+CR as EOL
				.if	((al == 0dh) || (al == 0ah))
					mov	BYTE ptr [esi],0
					.if (ecx > 1)
						mov ah,[esi+1]
						.if (((ah == 0dh) || (ah == 0ah)) && (al != ah))
							inc esi
							dec ecx
						.endif
					.endif
if ?LOGREQUEST
					DebugOut ">%.250s<", edi
endif
					.if (byte ptr [edi] == 0)		;Blank line (end of header)?
						.if (ecx > 1)
							inc	esi
							dec ecx
							mov	m_pszBodyIn,esi
;------------------------------------- read body data (POST)
;------------------------------------- if not yet read
							.if (ecx < m_dwConLenIn)
								mov eax,m_dwConLenIn
								sub eax, ecx
								add esi, ecx
								mov m_dwReadIn, ecx
								.if (eax > DataMaxRemain)
									mov eax, DataMaxRemain
								.endif
								invoke	recv, m_hSocket, esi, eax, 0
								.if (eax != SOCKET_ERROR)
									add g_dwBytesReceived,eax
									add m_dwReadIn, eax
								.endif
							.endif
						.endif
						invoke	ServeContent, __this
						.if (m_bKeepAlive)
							invoke ResetRequest, __this
							mov bReused, TRUE
							mov	DataMaxRemain,?BUFSIZE-1
							mov esi,m_pBufferIn
							mov edi,esi
						.else
							mov DataMaxRemain,0
						.endif
						.break
					.endif
					push ecx
					.if (!m_Action)
						invoke	GetHTTPMethod, __this, edi
					.else
						.if (!m_pszHeaderIn)		;save start of header
							mov m_pszHeaderIn, edi
						.endif
						.if (byte ptr [edi] > ' ')	;continuation line?
							invoke	GetHTTPNextParm, __this, edi
						.else
							.if (edi > m_pszHeaderIn)
								mov word ptr [edi-2], '  '
							.endif
						.endif
					.endif
					pop ecx
					lea	edi,[esi+1]					;edi -> start of next line
				.endif
				inc esi
				dec	ecx
			.endw
		.endif
	.endw
	ret
	align 4

GetData@CHTTPRequest endp



Destroy@CHTTPRequest proc public uses __this this_:ptr CHTTPRequest

	DebugOut "Destroy@CHTTPRequest"

	mov __this,this_

	.if (m_hSocket != INVALID_SOCKET)
		invoke	shutdown, m_hSocket, SD_SEND
		invoke	closesocket, m_hSocket
	.endif

	.if (m_pBufferOut)
		invoke free, m_pBufferOut
		mov m_pBufferOut, NULL
	.endif

	invoke free, __this
	ret
	align 4

Destroy@CHTTPRequest	endp

	end

