
;--- macros:
;--- CStr()
;--- L()
;--- CStrW()
;--- smalloc, sfree, sreload
;--- return
;--- @mov
;--- MEMBER

ifndef CStr

;--- CStr() define a string in .CONST
;--- or in .CONST$2 if .CONST is the current section

CStr macro y:req, name
local sym,xxx
xxx	textequ @CurSeg
ifidni xxx,<CONST>
CONST$2 segment para public 'CONST'
else
 if @Model
	.const
 else
CONST segment dword public 'CONST'
 endif
endif
ifnb <name>
  ifidni <y>,<"">
    name db 0
  else
    name db y,0
  endif
else
  ifidni <y>,<"">
    sym db 0
  else
    sym db y,0
  endif
endif
ifidni xxx,<CONST>
CONST$2 ends
else
 if @Model
   ifidni xxx,<_TEXT>
     .code
   else
     .data
   endif
 else
CONST ends
 endif
endif
ifnb <name>
	exitm <offset name>
else
	exitm <offset sym>
endif
	endm

endif

ifndef __POASM__
ifndef L

;---- L() defines a wide string
;---- usage: StringName dw L(stringvalue)

L macro parms:VARARG
local wstr,i,c,tstr
    wstr textequ <>
    i = 0
    for parm,<parms>
      c SubStr <parm>,1,1
      ifidn c,<">
        tstr SubStr <parm>,2,@SizeStr(parm)-2    
%       forc chr$,<tstr>
          if i
            wstr CatStr wstr,<,>
          endif
          wstr CatStr wstr,<'&chr$'>
          i = i + 1      
        endm
      else  
        if i
          wstr CatStr wstr,<,>
        endif
        wstr CatStr wstr,<parm>
      endif
    endm
    exitm <wstr>
endm	
endif
endif

;--- CStrW defines a wide string in .CONST
;--- returns a pointer to that string

CStrW	macro y:req
local sym,xxx

xxx	textequ @CurSeg
ifidni xxx,<CONST>
CONST$2 segment para public 'CONST'
else
	.const
endif
	align 2
sym dw y,0

ifidni xxx,<CONST>
CONST$2 ends
else
 ifidni xxx,<_TEXT>
	.code
 else
	.data
 endif
endif
	exitm <offset sym>
	endm


ifndef smalloc

;--- the smalloc + sfree macros are used to alloc space
;--- on the stack.
;--- usage: "smalloc register,numBytes" and "sfree"

smalloc macro reg:req,bytes:req	;alloc space on the stack (local only)
local ?bytes
?bytes = (bytes + 3) and 0fffffffch
	sub esp,?bytes
	mov reg,esp
	push ?bytes+4
	endm
sreload macro reg:req,index		;reload address of stack items
ifnb <index>
	mov reg,esp
	repeat index
	add reg,[reg]
	endm
	add reg,4
else
	lea reg,[esp+4]
endif
	endm
sfree macro
	add esp,[esp]
	endm

endif	;smalloc


;--- return: return a value in eax

ifndef return

return macro x
ifnb <x>
 if (OPATTR x) eq 4	;;constant?
  if x
	mov eax,x
  else
	xor eax,eax
  endif
 else
	mov eax,x
 endif
endif
	ret
	endm

endif	;return

;--- simple macro for a 3 byte move, used i.e.: @mov ecx, 3

@mov	macro x, y
	push y
	pop x
	endm

ifndef MEMBER

;--- MEMBER: create member names
;--- requires at least one other definition in program itself.
;--- assume ebx is used to access this_. so define in program
;--- "_this	textequ <[ebx].CClassName>"
;--- "MEMBER VarName"
;--- so access to member 
;--- "[ebx].CClassName.VarName" simplifies to "m_VarName"

MEMBER	macro names:VARARG
local x
	for y,<names>
x	CatStr <_this.>,<y>
m_&y	textequ x
	endm
	endm

endif	;MEMBER



