
	.486
	.model flat,stdcall
	option casemap:none
	option proc:private

	include Httpdint.inc
	include Utility.inc

	.code

;*** scan interface tab and see if requested iface is in there
;*** return valid ptr or NULL

if 0

IsInterfaceSupported proc public uses ebx esi edi pReqIF:ptr IID, pIFTab:ptr ptr IID, dwEntries:dword, this_:ptr, ppReturn:ptr LPUNKNOWN
	
	mov ecx,dwEntries
	mov esi,pIFTab
	mov ebx,0
	.while (ecx)
		lodsd
		mov edi,eax
		lodsd
		mov edx,eax
		mov eax,esi
		mov esi,pReqIF
		push ecx
		mov ecx,4
		repz cmpsd
		pop ecx
		.if (ZERO?)
			mov ebx,edx
			add ebx,this_
			.break
		.endif
		mov esi,eax
		dec ecx
	.endw
	mov ecx,ppReturn
	mov [ecx],ebx

	.if (ebx)
		invoke vf(ebx,IUnknown,AddRef)
		mov eax,S_OK
	.else
		mov eax,E_NOINTERFACE
	.endif
	ret
	align 4

IsInterfaceSupported endp

;--------------------------------------------------------------------------

;*** assign a COM pointer (with AddRef + Release)

ComPtrAssign proc public uses ebx pp:ptr LPUNKNOWN, lp:LPUNKNOWN
	.if (lp != NULL)
		invoke vf(lp,IUnknown,AddRef)
	.endif
	mov ebx,pp
	.if (dword ptr [ebx])
		invoke vf([ebx],IUnknown,Release)
	.endif
	mov eax,lp
	mov [ebx],eax
	ret
	align 4

ComPtrAssign endp

endif

;--------------------------------------------------------------------------

;*** lstrcmpiW: do not use the kernel32 instance

_strcmpiW	proc public pstr1:ptr WORD, pstr2:ptr WORD
	mov ecx,pstr1
	mov edx,pstr2
	.while (1)
		mov ax,[ecx]
		cmp ax,[edx]
		.break .if (!ZERO?)
		.if (!ax)
			return 0
		.endif
		add ecx,2
		add edx,2
	.endw
	return 1
	align 4

_strcmpiW	endp

c2c proc
	cmp al,'a'
	jb  @F
	cmp al,'z'
	ja  @F
	sub al,'a'-'A'
@@:
	ret
	align 4
c2c	endp

;--- not exactly the CRT memcmp, cause result is 0/1 only

if 0
memcmp	proc public uses esi edi pszStr1:ptr BYTE, pszStr2:ptr BYTE, dwLength:DWORD
	mov esi, pszStr1
	mov edi, pszStr2
	mov ecx, dwLength
	xor eax,eax
	repz cmpsb
	setne al
	ret
	align 4

memcmp endp
endif

_memicmp	proc c public uses esi edi pstr1:ptr, pstr2:ptr, dwSize:DWORD
	mov esi,pstr1
	mov edi,pstr2
	mov ecx,dwSize
	.while (ecx)
		mov al,[edi]
		inc edi
		or al,20h
		mov ah,al
		lodsb
		or al,20h
		.if (al != ah)
			return 1
		.endif
		dec ecx
	.endw
	return 0
	align 4

_memicmp	endp

whitechar	proc
	cmp		al,' '
	jz		done
	cmp		al,9
	jz		done
	cmp		al,13
	jz		done
	cmp		al,10
	jz		done
done:
	ret
	align 4

whitechar endp

operators proc
	cmp al,'='
	jz done
done:
	ret
	align 4

operators endp

;*** get a token from a text line

GetToken proc public uses esi edi pszText:LPSTR, pszToken:LPSTR, dwMax:DWORD
	
	mov esi,pszText
	.while (1)
		lodsb
		invoke	whitechar
		.break .if (!ZERO?)
	.endw
	dec esi
	mov edi,pszToken
	mov ecx,dwMax
	dec ecx
	xor edx,edx
	.while (ecx)
		lodsb
		.if ((dl == 0) && (al == '"'))
			mov dh,1
			.continue
		.elseif (dh && (al == '"'))
			mov dh,0
			.continue
		.elseif (!dh)
			invoke whitechar
			.break .if (ZERO?)
			invoke operators
			.if (ZERO?)
				.break .if (dl)
				stosb
				inc esi
				.break
			.endif
		.endif
		invoke c2c
		stosb
		inc dl
		dec ecx
	.endw
	mov al,0
	stosb
	lea eax,[esi-1]
	ret
	align 4

GetToken endp

;*** display protocol line

printf	proc c public pStr:LPSTR, parms:VARARG

	pushad
	sub	esp,1024
	mov esi,esp
	invoke wvsprintf, esi, pStr, addr parms
	.if (g_lpfnprintf)
    	invoke g_lpfnprintf, esi
	.else
		invoke OutputDebugString, esi
		invoke OutputDebugString, CStr(<0dh,0ah>)
	.endif
	add esp,1024
	popad
	ret
	align 4

printf	endp

;*** split parameter string in single words (decode URL %)

ExtractParams proc public uses ebx edi esi pszRawString:LPSTR

local pszStrBegin:LPSTR
local bVar:BOOL

	xor ecx,ecx
	mov edx,pszRawString
	.if (edx)
		.while (1)
			mov al,[edx]
			.break .if (!al)
			.if (al == '&')
				inc ecx
			.endif
			inc edx
		.endw
	.endif
	mov eax,ecx
	shl eax,4			;for each parameter reserve 2*4 bytes
	add eax,4			;1 extra dword for terminating 0
	invoke malloc, eax
	mov ebx,eax
	mov esi,eax
	mov edx,pszRawString
	mov pszStrBegin,edx
	mov bVar,FALSE
	.while (edx)
		mov al,[edx]
		.if (((al == '=') && (bVar == FALSE)) || (al == '&') || (al == 0))
			push edx
			mov eax,edx
			sub eax,pszStrBegin
			push eax
			inc eax
			invoke malloc, eax
			pop ecx
			mov [esi],eax
			add esi,4
			push esi
			mov esi,pszStrBegin
			mov edi,eax
			.while (ecx)
				lodsb
				.if (al == '%')
					sub ecx,2
					.break .if (CARRY? || ZERO?)
					lodsb
					call Char2Nib
					mov ah,al
					lodsb
					call Char2Nib
					shl ah,4
					or al,ah
				.elseif (al == '+')
					mov al,' '
				.endif
				stosb
				dec ecx
			.endw
			xor al,al
			stosb
			pop esi
			pop edx
			lea eax,[edx+1]
			mov pszStrBegin,eax
			mov al,[edx]
			.if ((al == '&') || (al == 0))
				.if (bVar == FALSE)
					mov dword ptr [esi],0
					add esi,4
				.endif
				mov bVar,FALSE
				.break .if (al == 0)
			.else
				mov bVar,TRUE
			.endif
		.endif
		inc edx
	.endw
	mov dword ptr [esi],0
	return ebx
	align 4

ExtractParams	endp

Char2Nib	proc public
	cmp		al,41h
	jb		@F
	or		al,20h
	sub		al,61h-10
	ret
@@:
	sub		al,30h
	ret
	align 4
Char2Nib	endp

;*** convert string to number

String2Number proc public uses esi ebx pStr:LPSTR,pDW:ptr dword,radix:dword

		mov ecx,radix
		xor edx,edx
		mov esi,pStr
		mov bl,0
next:
		lodsb
		and al,al
		jz  exit
		cmp al,' '
		jz  exit
		sub al,'0'
		jc  errexit
		cmp al,9
		jbe @F
		cmp cl,16
		jc  errexit
		or  al,20h
		sub al,27h
		jc  errexit
		cmp al,10h
		cmc
		jc  errexit
@@:
		movzx eax,al
		push eax
		mov eax,edx
		mul ecx
		pop edx
		add edx,eax
		inc bl
		jmp next
exit:
		cmp bl,1	;C if 0 (error)		 
		jc	errexit
		mov eax,pDW
		mov [eax],edx
		lea eax,[esi-1]
		ret
errexit:
		xor eax,eax
		ret
		align 4
String2Number endp

;*** load ISAPI extension and put it in one of 2 pools
;*** call GetExtensionVersion

LoadISAPIExtension proc public uses esi pszName:LPSTR, dwExt:DWORD

	LOCAL	hLib:HINSTANCE
	LOCAL	pGEV:PFN_GETEXTENSIONVERSION
	LOCAL	pHEP:PFN_HTTPEXTENSIONPROC
	LOCAL	pTE:PFN_TERMINATEEXTENSION
	LOCAL	pszString:LPSTR
	LOCAL	vi:HSE_VERSION_INFO

	mov hLib, 0
	invoke	LoadLibrary, pszName
	.if (eax <= 32)
		invoke printf, CStr("LoadLibrary(%s) returned error %u!!!"), pszName, eax
		jmp error
	.endif
	mov hLib,eax

	invoke GetProcAddress, hLib, CStr("GetExtensionVersion")
	.if (!eax)
		invoke printf, CStr("GetExtensionVersion in %s not found!!!"), pszName
		jmp error
	.endif
	mov pGEV,eax

	invoke GetProcAddress, hLib, CStr("HttpExtensionProc")
	.if (!eax)
		invoke printf, CStr("HttpExtensionProc in %s not found!!!"), pszName
		jmp error
	.endif
	mov pHEP, eax

	invoke GetProcAddress, hLib, CStr("TerminateExtension")
	mov pTE, eax

;---------------------------- if its an associated dll check if it is loaded
;---------------------------- to avoid a second call to GetExtensionVersion
	mov eax,hLib
	xor ecx, ecx
	.if (dwExt)
		mov ecx, g_pISAPIMapping
		.while (ecx)
			.break .if ([ecx].CIsapi.hLib == eax)
			mov ecx,[ecx].CIsapi.pNext
		.endw
	.endif

	.if (!ecx)
		invoke pGEV, addr vi
		DebugOut "ISAPI::GetExtensionVersion returned %X, %s",\
			vi.dwExtensionVersion, addr vi.lpszExtensionDesc
	.endif

	.if (eax)
		mov eax, dwExt
		.if (!eax)
			invoke lstrlen, pszName
			inc eax
			invoke malloc, eax
			.if (!eax)
				jmp error
			.endif
			mov pszString, eax
			invoke lstrcpy, eax, pszName
		.else
			mov pszString, eax
		.endif

		invoke malloc, sizeof CIsapi
		.if (!eax)
			jmp error
		.endif
		assume eax:ptr CIsapi
		mov [eax].pNext, NULL
		.if (dwExt)
			lea ecx, g_pISAPIMapping
		.else
			lea ecx, g_pISAPI
		.endif
		.while ([ecx].CIsapi.pNext)
			mov ecx,[ecx].CIsapi.pNext
		.endw
		mov [ecx].CIsapi.pNext, eax
		mov ecx,hLib
		mov [eax].hLib, ecx
		mov ecx,pHEP
		mov [eax].pHEP, ecx
		mov ecx,pTE
		mov [eax].pTE, ecx
		mov ecx, pszString
		mov [eax].pszName, ecx
		assume eax:nothing
	.else
		invoke printf, CStr("%s::GetExtensionVersion returned FALSE"), pszName
		jmp error
	.endif
	ret
error:
	.if (hLib)
		invoke FreeLibrary, hLib
	.endif
	return 0
	align 4

LoadISAPIExtension endp


;*** alloc memory, no zeroinit, raise exception on error


malloc	proc public dwBytes:DWORD
		invoke HeapAlloc, g_hHeap, HEAP_GENERATE_EXCEPTIONS, dwBytes
		ret
malloc	endp

free	proc public pMem:LPVOID
		invoke HeapFree,g_hHeap,0,pMem
		ret
free	endp

	END
